/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.academia.Services;

import org.json.JSONObject;
import pe.siso.academia.DAO.DAOFactory;
import pe.siso.academia.DAO.PermisosDAO;

/**
 *
 * @author Felipe Escala
 */
public class PermisosService {

	DAOFactory factory = DAOFactory.getDAOFactory(DAOFactory.MYSQL);
	PermisosDAO dao = factory.getPermisosDAO();

	public JSONObject listarPermisos(JSONObject datos) {
		JSONObject obj = null;
		try {
			obj = dao.listarPermisos(datos);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return obj;
	}

	public JSONObject listarEstudiantes(JSONObject datos) {
		JSONObject obj = null;
		try {
			obj = dao.listarEstudiantes(datos);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return obj;
	}

	public JSONObject registrarPermisos(JSONObject datos) {
		JSONObject obj = null;
		try {
			obj = dao.registrarPermisos(datos);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return obj;
	}

	public JSONObject eliminarPermiso(JSONObject datos) {
		JSONObject obj = null;
		try {
			obj = dao.eliminarPermiso(datos);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return obj;
	}

	public JSONObject editarPermiso(JSONObject datos) {
		JSONObject obj = null;
		try {
			obj = dao.editarPermiso(datos);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return obj;
	}
}
