<%-- 
    Document   : man_permisos
    Created on : 31-ago-2018, 9:06:27
    Author     : Felipe Escala
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@ include file="validar.jsp" %>
<!DOCTYPE html>
<html>
  <head>
    <!-- START @META SECTION -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
    <meta name="description" content="Blankon is a theme fullpack admin template powered by Twitter bootstrap 3 front-end framework. Included are multiple example pages, elements styles, and javascript widgets to get your project started.">
    <meta name="keywords" content="admin, admin template, bootstrap3, clean, fontawesome4, good documentation, lightweight admin, responsive dashboard, webapp">
    <meta name="author" content="Djava UI">
    <title>SISTEMA CUOTAS PAGO ACADEMIA</title>
    <link rel="icon" type="image/png" sizes="16x16" href="images/helicoide.png" />
    <!-- START @FONT STYLES -->
    <link href="http://fonts.googleapis.com/css?family=Open+Sans:400,300,600,700" rel="stylesheet">
    <link href="http://fonts.googleapis.com/css?family=Oswald:700,400" rel="stylesheet">
    <!--/ END FONT STYLES -->

    <!-- START @GLOBAL MANDATORY STYLES -->
    <link href="../limitless/assets/css/icons/icomoon/styles.css" rel="stylesheet" type="text/css">
    <!--<link href="../limitless/assets/css/components.css" rel="stylesheet" type="text/css">-->
    <link href="../assets/global/plugins/bower_components/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">
    <link href="../assets/global/plugins/bower_components/bootstrap-switch/dist/css/bootstrap3/bootstrap-switch.min.css" rel="stylesheet">
    <!--/ END GLOBAL MANDATORY STYLES -->

    <!-- START @PAGE LEVEL STYLES -->
    <link href="../assets/global/plugins/bower_components/fontawesome/css/font-awesome.min.css" rel="stylesheet">
    <link href="../assets/global/plugins/bower_components/animate.css/animate.min.css" rel="stylesheet">
    <link href="../assets/global/plugins/bower_components/dropzone/downloads/css/dropzone.css" rel="stylesheet">
    <link href="../assets/global/plugins/bower_components/jquery.gritter/css/jquery.gritter.css" rel="stylesheet">
    <!--/ END PAGE LEVEL STYLES -->

    <!-- DATEPICKER CSS INICIO -->
    <link href="../assets/global/plugins/bower_components/bootstrap-daterangepicker/daterangepicker.css" rel="stylesheet">
    <!-- DATEPICKER CSS FINAL -->

    <!-- START @THEME STYLES -->


    <link href="../assets/admin/css/reset.css" rel="stylesheet">
    <link href="../assets/admin/css/layout.css" rel="stylesheet">
    <link href="../assets/admin/css/components.css" rel="stylesheet">
    <!--<link href="../assets/admin/css/plugins.css" rel="stylesheet">-->
    <link href="../assets/admin/css/themes/red.theme.css" rel="stylesheet" id="theme">
    <link href="../assets/admin/css/custom.css" rel="stylesheet">
    <link rel="stylesheet" href="validar/css/validationEngine.jquery.css" type="text/css"/>
    <link href="../css/pages/select2.css" rel="stylesheet" type="text/css"/>
    <link href="../css/datatables.css" rel="stylesheet" type="text/css"/>
    <link href="../css/pages/general.css" rel="stylesheet" type="text/css"/>
    <style>
      .btn-slate {
        color: #FFF;
        background-color: #607D8C;
        border-color: #586c76;
        text-shadow: 0 -1px 0 rgba(0, 0, 0, 0.1);
      }
      .panel>.table-responsive {
        margin-bottom: -20px;
        border: 0;
      }
      table.dataTable.stripe tbody tr.odd, table.dataTable.display tbody tr.odd {
        background-color: #ffffff; 
      }
      table.dataTable.no-footer {
        border-bottom: none;
      }
      table.dataTable tbody th, table.dataTable tbody td {
        padding: 5px 10px;
      }      
      table.dataTable thead th, table.dataTable thead td {
        padding: 5px 10px;
        border-bottom: 1px #DDDDDD solid;
      }      
      .datepicker{z-index:9999 !important}
      .daterangepicker{z-index:9999 !important}
      .bg-darkBlue {
        background-color: #2D72AD !important;
        border: 1px solid #2D72AD;
        color: white;
      }
      form .form-group .error {
        display: block;
        font-style: initial ;
      }
      .modal-md {
        width: 400px;
      }
    </style>
  </head>
  <body class="page-sound page-header-fixed page-sidebar-fixed" onload="cargar();">
    <section id="wrapper">
      <%@ include file="banner.jsp" %>
      <input id="codTitulo" type="hidden" value='<%=menu != null ? menu.getCodigoTitulo() : ""%>'>
      <input id="codModulo" type="hidden" value='<%=menu != null ? menu.getCodigoModulo() : ""%>'>
      <input id="codCategoria" type="hidden" value='<%=menu != null ? menu.getCodigoCategoria() : ""%>'>
      <input id="codSubCategoria" type="hidden" value='<%=menu != null ? menu.getCodigoSubCategoria() : ""%>'>
      <%@ include file="menu.jsp" %>
      <section id="page-content">


        <div class="header-content">
          <h2><i class="fa fa-cogs"></i>Asistencia <span>Mantenimiento de Permisos</span></h2>
          <div class="breadcrumb-wrapper hidden-xs">
          </div>
        </div>


        <div class="body-content animated fadeIn">
          <div class="row">

            <div class="col-md-6 col-md-offset-3">
              <div class="panel rounded shadow panel-blueDark panelborder">
                <div class="panel-heading ">
                  <div class="pull-left">
                    <h3 class="panel-title"><i class="fa fa-search"></i>Búsqueda de Permisos</h3>
                  </div>
                  <div class="clearfix"></div>
                </div>
                <div class="panel-body no-padding">
                  <form id="formBusqueda" onsubmit="return false;" autocomplete="off">
                    <div class="form-body">
                      <fieldset>
                        <div class="form-group col-md-6" id="txtFiltroTipo">
                          <label class="control-label"><b>Buscar por<span class="asterisk">&nbsp;(*)</span></b></label>
                          <select class="form-control" id="cboTipoFiltro">
                            <option value="1">Estudiante</option>
                            <option value="2">Fecha</option>
                          </select>
                        </div>
                        <div class="form-group col-md-6" id="colEstudiante">
                          <label class="control-label"><b>Nombre<span class="asterisk">&nbsp;(*)</span></b></label>                                                    
                          <select class="form-control listaEstudiante" id="txtEstudianteBusqueda" name="txtEstudianteBusqueda">
                            <option value="">[SELECCIONE]</option>
                          </select>
                        </div>
                        <div class="form-group col-md-6 hide" id="colFecha">
                          <label class="control-label"><b>Fecha<span class="asterisk">&nbsp;(*)</span></b></label>                                                    
                          <input type="text" class="form-control date-single-picker" id="txtFechaBusqueda" name="txtFechaBusqueda"/>
                        </div>
                        <div class="col-md-12">
                          <div class="form-group">
                            <div class="text-right"> 
                              <span class="text-danger">(*) </span>  Campo obligatorio
                            </div>
                          </div>
                        </div>
                      </fieldset>
                    </div>
                    <div class="form-footer">
                      <div class="pull-right">
                        <button id="btnBuscar" class="btn btn-foursquare" type="button"><i class="fa fa-search"></i> BUSCAR</button>
                        <button id="btnLimpiar" class="btn btn-warning" type="button"><i class="fa fa-refresh"></i> LIMPIAR</button>
                      </div>
                      <div class="clearfix"></div>
                    </div>
                  </form>
                </div>
              </div> 
            </div>

            <div class="col-md-8 col-md-offset-2">
              <div class="panel rounded shadow panel-blueDark panelborder">
                <div class="panel-heading blue2">
                  <div class="pull-left">
                    <h3 class="panel-title"><i class="fa fa-list-alt"></i>Listado de Permisos</h3>
                  </div>
                  <div class="pull-right">
                    <button id="btnNuevo"  type="button"  class="btn btn-slate"><i class="glyphicon glyphicon-plus "></i>&nbsp; Nuevo Permiso</button>
                  </div>                                           
                  <div class="clearfix"></div>
                </div>
                <div class="table-responsive" >

                  <table class="table table-responsive table-striped table-hover table-bordered display nowrap dataTable no-footer" style ="width: 100%" id="tblPermisos">                                                 
                    <thead class="bg-blue-600 ">
                      <tr>
                        <th class="text-center">Nº</th>
                        <th class="text-center">ALUMNO</th>
                        <th class="text-center">DESCRIPCIÓN</th>
                        <th class="text-center">FECHA INICIO</th>                                                    
                        <th class="text-center">FECHA FIN</th>
                        <th class="text-center">ESTADO</th>
                        <th class="text-center">ACCIONES</th>                                               
                      </tr>
                    </thead>
                  </table>
                </div>
                <br>
              </div> 
            </div>
          </div>
        </div>
        <%@ include file="footer.jsp" %>
      </section>
    </section>
    <div id="registrarPermisos" class="modal fade" data-backdrop='static'>
      <div class="modal-dialog" >
        <div class="modal-content">
          <div class="modal-header bg-darkBlue">
            <h4 class="modal-title">Registrar Permisos</h4>
          </div>
          <div class="modal-body">
            <form id="formNuevo" onsubmit="return false" autocomplete="off">
              <div class="row">
                <div class="col-md-6">
                  <div class="form-group">                                          
                    <label>Estudiante: <span class="asterisk">(*)</span></label>
                    <select class="form-control listaEstudiante" id="cboEstudiante" name="cboEstudiante">
                      <option value="">[SELECCIONE]</option>
                    </select>
                  </div>
                </div>
                <div class="col-md-6">
                  <div class="form-group">
                    <label>Fecha: <span class="asterisk">(*)</span></label>
                    <input class="form-control date-range-picker-double-Top" id="cboFecha" name="cboFecha" type="text" readonly=""/>
                  </div>
                </div>
                <div class="col-md-12">
                  <div class="form-group">
                    <label>
                      Descripción:    <span class="asterisk">(*)</span>
                    </label>
                    <textarea class="form-control" id="taDescripcion" name="taDescripcion" placeholder="Ingrese la descripcion" rows="5"></textarea>
                  </div>
                </div>
                <div class="col-md-12">
                  <div class="form-group">
                    <div class="text-right"> 
                      <span class="text-danger">(*) </span>  Campo obligatorio
                    </div>
                  </div>
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button type="button" id="btnAgregarPermiso" class="btn btn-success">Crear</button>
            <button type="button" class="btn btn-danger" id="btnCancelarRegistro">Cancelar</button>
          </div>
        </div>
      </div>
    </div>
    <div id="editarPermisos" class="modal fade" data-backdrop='static'>
      <div class="modal-dialog modal-md">
        <div class="modal-content">
          <div class="modal-header bg-darkBlue">
            <h4 class="modal-title">Editar Permisos</h4>
          </div>
          <div class="modal-body">
            <form id="formEditar" onsubmit="return false" autocomplete="off">
              <div class="row">
                <div class="col-md-12">
                  <div class="form-group">
                    <h5>
                      <i class="fa fa-user" id="dataUser"></i>
                      <input type="hidden" id="codigoPermiso">
                    </h5>
                  </div>
                </div>
                <div class="col-md-12">
                  <div class="form-group">
                    <label>Fecha: <span class="asterisk">(*)</span></label>
                    <input class="form-control date-range-picker-double-Top" id="txtFecha" name="txtFecha" type="text" readonly=""/>
                  </div>
                </div>
                <div class="col-md-12">
                  <div class="form-group">
                    <label>
                      Descripción:    <span class="asterisk">(*)</span>
                    </label>
                    <textarea class="form-control" id="txtDescripcion" name="txtDescripcion" placeholder="Ingrese la descripcion" rows="5"></textarea>
                  </div>
                </div>
                <div class="col-md-12">
                  <div class="form-group">
                    <div class="text-right"> 
                      <span class="text-danger">(*) </span>  Campo obligatorio
                    </div>
                  </div>
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button type="button" id="btnEditarPermiso" class="btn btn-success">Editar</button>
            <button type="button" class="btn btn-danger" id="btnCancelarEdicion">Cancelar</button>
          </div>
        </div>
      </div>
    </div>

    <div id="back-top" class="animated pulse circle">
      <i class="fa fa-angle-up"></i>
    </div>
    <!-- START JAVASCRIPT SECTION (Load javascripts at bottom to reduce load time) -->
    <!-- START @CORE PLUGINS -->
    <script src="../assets/global/plugins/bower_components/jquery/dist/jquery.min.js"></script>
    <script src="../assets/global/plugins/bower_components/jquery-cookie/jquery.cookie.js"></script>
    <script src="../assets/global/plugins/bower_components/bootstrap/dist/js/bootstrap.min.js"></script>
    <script src="../assets/global/plugins/bower_components/typehead.js/dist/handlebars.js"></script>
    <script src="../assets/global/plugins/bower_components/typehead.js/dist/typeahead.bundle.min.js"></script>
    <script src="../assets/global/plugins/bower_components/jquery-nicescroll/jquery.nicescroll.min.js"></script>
    <script src="../assets/global/plugins/bower_components/jquery.sparkline.min/index.js"></script>
    <script src="../assets/global/plugins/bower_components/jquery-easing-original/jquery.easing.1.3.min.js"></script>
    <script src="../assets/global/plugins/bower_components/ionsound/js/ion.sound.min.js"></script>
    <script src="../assets/global/plugins/bower_components/bootbox/bootbox.js"></script>
    <!--/ END CORE PLUGINS -->

    <!-- START @PAGE LEVEL PLUGINS -->
    <!--<script src="../assets/global/plugins/bower_components/bootstrap-session-timeout/dist/bootstrap-session-timeout.min.js"></script>-->
    <script src="../assets/global/plugins/bower_components/flot/jquery.flot.js"></script>
    <script src="../assets/global/plugins/bower_components/flot/jquery.flot.spline.min.js"></script>
    <script src="../assets/global/plugins/bower_components/flot/jquery.flot.categories.js"></script>
    <script src="../assets/global/plugins/bower_components/flot/jquery.flot.tooltip.min.js"></script>
    <script src="../assets/global/plugins/bower_components/flot/jquery.flot.resize.js"></script>
    <script src="../assets/global/plugins/bower_components/flot/jquery.flot.pie.js"></script>
    <script src="../assets/global/plugins/bower_components/dropzone/downloads/dropzone.min.js"></script>
    <script src="../assets/global/plugins/bower_components/jquery.gritter/js/jquery.gritter.min.js"></script>
    <script src="../assets/global/plugins/bower_components/skycons-html5/skycons.js"></script>
    <!--/ END PAGE LEVEL PLUGINS -->

    <!-- DATEPICKER JS INICIO -->
    <script src="../assets/global/plugins/bower_components/moment/min/moment.min.js"></script>
    <script src="../assets/global/plugins/bower_components/bootstrap-daterangepicker/daterangepicker.js"></script>
    <script src="../limitless/assets/js/plugins/forms/validation/validate.min.js" type="text/javascript"></script>
    <!-- DATEPICKER JS FINAL -->

    <!-- START @PAGE LEVEL SCRIPTS -->
    <script src="../assets/admin/js/apps.js"></script>
    <script src="../assets/admin/js/pages/blankon.dashboard.js"></script>
    <script src="../assets/plugin/datatables.min.js" type="text/javascript"></script>
    <script src="../assets/plugin/bootbox.min.js" type="text/javascript"></script>
    <script src="../assets/plugin/validateAlfi.js" type="text/javascript"></script>     
    <script src="../js/general.js" type="text/javascript"></script>
    <script src="../assets/plugin/select2.min.js" type="text/javascript"></script>
    <script type="text/javascript">
                 segundaCarga = () => {
                    initComponents.init()
                    DOMEvents.init()
                    convertirDateTimePicker()
                    dateSinglePicker()
                 }

                 const helpers = {
                    tblCharge() {
                       tablePermisos.destroy()
                       initComponents.listarPermisos()
                    },
                    tblRefresh() {
                       tablePermisos.ajax.reload(null, false);
                    }
                 }

                 const httpRequest = {
                    listarPermisos(json) {
                       return new Promise((resolve, reject) => {
                          $.ajax({
                             type: 'POST',
                             url: "../ServletPermiso?accion=listarPermisos",
                             dataType: "json",
                             data: {
                                json: JSON.stringify(json)
                             },
                             success: function (data, textStatus, jqXHR) {
                                resolve(data)
                             }, error: function (jqXHR, textStatus, errorThrown) {
                                reject('Error en la petición')
                             }
                          })
                       })
                    },
                    registrarPermisos(json) {
                       return new Promise((resolve, reject) => {
                          $.ajax({
                             type: 'POST',
                             url: "../ServletPermiso?accion=registrarPermisos",
                             dataType: "json",
                             data: {
                                json: JSON.stringify(json)
                             },
                             success: function (data, textStatus, jqXHR) {
                                resolve(data)
                             }, error: function (jqXHR, textStatus, errorThrown) {
                                reject('Error en la petición')
                             }
                          })
                       })
                    },
                    eliminarPermiso(json) {
                       return new Promise((resolve, reject) => {
                          $.ajax({
                             type: 'POST',
                             url: "../ServletPermiso?accion=eliminarPermiso",
                             dataType: "json",
                             data: {
                                json: JSON.stringify(json)
                             },
                             success: function (data, textStatus, jqXHR) {
                                resolve(data)
                             }, error: function (jqXHR, textStatus, errorThrown) {
                                reject('Error en la petición')
                             }
                          })
                       })
                    },
                    editarPermiso(json) {
                       return new Promise((resolve, reject) => {
                          $.ajax({
                             type: 'POST',
                             url: "../ServletPermiso?accion=editarPermiso",
                             dataType: "json",
                             data: {
                                json: JSON.stringify(json)
                             },
                             success: function (data, textStatus, jqXHR) {
                                resolve(data)
                             }, error: function (jqXHR, textStatus, errorThrown) {
                                reject('Error en la petición')
                             }
                          })
                       })
                    }
                 }

                 const DOMEvents = {
                    init() {
                       this.resetBusqueda()
                       this.agregarPermiso()
                       this.registrarPermiso()
                       this.buscarPermisos()
                       this.cancelarRegistro()
                       this.eliminarPermiso()
                       this.editarPermiso()
                       this.cancelarEdicion()
                       this.btnEditarPermiso()
                       this.checkSelects()
                    },
                    resetBusqueda() {
                       $('#btnLimpiar').click(() => {
                          $('#formBusqueda').trigger("reset");
                          $('#cboTipoFiltro').change()
                          helpers.tblCharge()
                       })
                    },
                    cancelarRegistro() {
                       $('#btnCancelarRegistro').click(() => {
                          $('#registrarPermisos').modal('hide')
                          $('#formNuevo').trigger("reset");
                          $('#cboEstudiante').trigger("change")
                       })
                    },
                    cancelarEdicion() {
                       $('#btnCancelarEdicion').click(() => {
                          $('#editarPermisos').modal('hide')
                          $('#formEditar').trigger("reset");
                       })
                    },
                    buscarPermisos() {
                       $('#btnBuscar').click(() => {
                          var valBusqueda = $("#formBusqueda").validate({
                             rules: {
                                txtFechaBusqueda: {required: true},
                                txtEstudianteBusqueda: {required: true, spaceNotAllowed: ' '}
                             },
                             messages: {
                                txtFechaBusqueda: {required: "<b>&times;</b>&nbsp;Este campo es requerido"},
                                txtEstudianteBusqueda: {required: "<b>&times;</b>&nbsp;Este campo es requerido"}
                             }
                          });
                          if (valBusqueda.form()) {
                             helpers.tblCharge()
                          }
                       })
                    },
                    agregarPermiso() {
                       $('#btnNuevo').click(() => {
                          $('#registrarPermisos').modal('show')
                       })
                    },
                    registrarPermiso() {
                       $('#btnAgregarPermiso').click(() => {
                          let rangoFechas = $('#cboFecha').val()
                          let fecha = rangoFechas.split(' - ')
                          var valRegistroPermiso = $("#formNuevo").validate({
                             rules: {
                                cboEstudiante: {required: true},
                                taDescripcion: {
                                   required: true,
                                   spaceNotAllowed: ' '
                                },
                                cboFecha: {required: true}
                             },
                             messages: {
                                cboEstudiante: {required: "<b>&times;</b>&nbsp;Este campo es requerido"},
                                taDescripcion: {required: "<b>&times;</b>&nbsp;Este campo es requerido"},
                                cboFecha: {required: "<b>&times;</b>&nbsp;Este campo es requerido"}
                             },
                             errorPlacement:
                                     function (error, element) {
                                        if (element.attr("id") === "cboEstudiante") {
                                           error.insertAfter(".select2-container");
                                        } else {
                                           error.insertAfter(element);
                                        }
                                     }
                          });
                          if (valRegistroPermiso.form()) {
                             httpRequest.registrarPermisos({
                                'codigoEstudiante': $('#cboEstudiante').val(),
                                'descripcionPermiso': $('#taDescripcion').val(),
                                'inicioPermiso': fecha[0],
                                'finPermiso': fecha[1]
                             })
                                     .then((data) => {
                                        if (data.status) {
                                           $('#registrarPermisos').modal('hide')
                                           msnSuccess("Permiso agregado correctamente", () => {
                                              $('#formNuevo').trigger("reset");
                                              $('#cboEstudiante').trigger("change")
                                              helpers.tblRefresh()
                                           })
                                        } else {
                                           msnError(data.message)
                                        }
                                     })
                          }
                       })
                    },
                    eliminarPermiso() {
                       $('#tblPermisos tbody').on('click', '.eliminar', (e) => {
                          let thisNode = e.currentTarget;
                          let data = tablePermisos.row($(thisNode).parents('tr')).data();
                          msnConfirm(`<label>¿Seguro de eliminar este Permiso?</label>`, (option) => {
                             if (option) {
                                httpRequest.eliminarPermiso(data)
                                        .then((data) => {
                                           if (data.status) {
                                              helpers.tblRefresh()
                                              msnSuccess("Permiso correctamente eliminado")
                                           } else {
                                              if ((data.message).includes('--->')) {
                                                 msnError("Ha ocurrido un error")
                                              } else {
                                                 msnError(data.message)
                                              }
                                           }
                                        })
                                        .catch(err => console.log(err))
                             }
                          });
                       })
                    },
                    editarPermiso() {
                       $('#tblPermisos tbody').on('click', '.editar', (e) => {
                          let thisNode = e.currentTarget;
                          let data = tablePermisos.row($(thisNode).parents('tr')).data();
                          $('#editarPermisos').modal('show')
                          $('#dataUser').text(" " + data.nombreEstudiante)
                          $('#txtFecha').val(data.inicioPermiso + ' - ' + data.finPermiso)
                          basicPicker()
                          $('#txtDescripcion').text(data.descripcionPermiso)
                          $('#codigoPermiso').val(data.codigoPermiso)
                       })
                    },
                    btnEditarPermiso() {
                       $('#btnEditarPermiso').click(() => {
                          let rangoFechas = $('#txtFecha').val()
                          let fecha = rangoFechas.split(' - ')
                          var valRegistroPermiso = $("#formEditar").validate({
                             rules: {
                                txtDescripcion: {required: true, spaceNotAllowed: ' '},
                                txtFecha: {required: true}
                             },
                             messages: {
                                txtDescripcion: {required: "<b>&times;</b>&nbsp;Este campo es requerido"},
                                txtFecha: {required: "<b>&times;</b>&nbsp;Este campo es requerido"}
                             }
                          });
                          if (valRegistroPermiso.form()) {
                             httpRequest.editarPermiso({
                                'descripcionPermiso': $('#txtDescripcion').val(),
                                'inicioPermiso': fecha[0],
                                'finPermiso': fecha[1],
                                'codigoPermiso': $('#codigoPermiso').val()
                             })
                                     .then((data) => {
                                        if (data.status) {
                                           $('#editarPermisos').modal('hide')
                                           helpers.tblRefresh()
                                           msnSuccess("Permiso correctamente editado", () => {
                                              $('#formEditar').trigger("reset");
                                           })
                                        } else {
                                           if ((data.message).includes('--->')) {
                                              msnError("Ha ocurrido un error")
                                           } else {
                                              msnError(data.message)
                                           }
                                        }
                                     })
                                     .catch(err => console.log(err))
                          }
                       })
                    },
                    checkSelects() {
                       $('#cboTipoFiltro').change((e) => {
                          _this = e.currentTarget
                          if (_this.value === '1') {
                             $('#colEstudiante').removeClass('hide')
                             $('#colFecha').addClass('hide')
                          } else if (_this.value === '2') {
                             $('#colEstudiante').addClass('hide')
                             $('#colFecha').removeClass('hide')
                          }
                       })
                    }
                 }

                 const initRequest = {
                 }

                 const initComponents = {
                    init() {
                       this.listarPermisos()
                       this.listarEstudiantes()
                    },
                    listarPermisos() {
                       json = {}
                       if ($('#cboTipoFiltro').val() === '1' && $('#txtEstudianteBusqueda').val() !== '') {
                          json.estudianteBusqueda = $('#txtEstudianteBusqueda').val()
                       } else if ($('#cboTipoFiltro').val() === '2' && $('#txtFechaBusqueda').val() !== '') {
                          json.fechaBusqueda = $('#txtFechaBusqueda').val()
                       }
                       tablePermisos = $("#tblPermisos").DataTable({
                          "language": {
                             "lengthMenu": "Mostrar: _MENU_",
                             "zeroRecords": "&nbsp;&nbsp;&nbsp; No se encontraron resultados",
                             "info": "&nbsp;&nbsp;&nbsp; Mostrando del _START_ al _END_ de un total de _TOTAL_ registros",
                             "infoEmpty": "&nbsp;&nbsp;&nbsp; Mostrando 0 de 0 registros",
                             "search": "Filtrar:",
                             "loadingRecords": "Cargando...",
                             "processing": '<span style="width:100%;"><img src="../../img/ajax-loader-img.gif" alt=""/></span>',
                             "paginate": {
                                "first": "First",
                                "last": "Last",
                                "next": "Siguiente",
                                "previous": "Anterior"
                             }
                          },
                          dom: '<"datatable-scroll"t>r<"datatable-footers"ip>',
                          ajax: {
                             type: 'POST',
                             url: "../ServletPermiso?accion=listarPermisos",
                             data: {
                                json: JSON.stringify(json)
                             }
                          },
                          "bSort": false,
                          "bFilter": false,
                          "serverSide": true,
                          "processing": true,
                          "aaSorting": [],
                          "ordering": false,
                          "bLengthChange": false,
                          "bInfo": true,
                          "paging": true,
                          "iDisplayLength": 15,
                          "columnDefs": [
                             {targets: 0, orderable: false, width: "5%", className: "text-center"},
                             {targets: 1, orderable: false, width: "20%"},
                             {targets: 2, orderable: false, width: "30%", className: "text-center"},
                             {targets: 3, orderable: false, width: "10%", className: "text-center"},
                             {targets: 4, orderable: false, width: "10%", className: "text-center"},
                             {targets: 5, orderable: false, width: "5%", className: "text-center"},
                             {targets: 6, orderable: false, width: "5%", className: "text-center"}
                          ],
                          "columns": [
                             {"data": "numeral"},
                             {"data": null, "render": (data, type, row) => {
                                   return capitalizeWords(row.nombreEstudiante);
                                }
                             },
                             {"data": "descripcionPermiso"},
                             {"data": "inicioPermiso"},
                             {"data": "finPermiso"},
                             {"data": null, "render": (data, type, row) => {
                                   if (row.vigenciaPermiso === 1) {
                                      return `<span class="label label-success">ACTIVO</span>`
                                   } else {
                                      return `<span class="label label-danger">INACTIVO</span>`
                                   }
                                }
                             },
                             {"data": null, "render": (data, type, row) => {
                                   return `<span class='editar'><i class="fa fa-pencil bigger-140 blue"></i>&nbsp;&nbsp;</span>
                                                                     <span class='eliminar'><i class="fa fa-trash-o bigger-140 red"></i>&nbsp;&nbsp;</span>`
                                }
                             }
                          ]
                       });
                    },
                    listarEstudiantes() {
                       ajaxRemoteSelect2({
                          id: ".listaEstudiante",
                          url: '../ServletPermiso?accion=listarEstudiantes',
                          data: params => {
                             return {
                                search: params.term,
                                page: params.page || 1
                             };
                          }
                          ,
                          placeholder: 'Buscar por nombre o dni',
                          minimumInputLength: 1,
                          templateResult: repo => {
                             if (repo.loading) {
                                return repo.text;
                             }
                             var markup = '<option value="' + repo.id + '">' + repo.nombre + '</option>';
                             return markup;
                          },
                          templateSelection: repo => {
                             let text = 'Buscar por nombre o dni';
                             if (repo.id) {
                                text = repo.nombre;
                             }
                             return text;
                          }
                       });
                    }
                 }
                 var f = new Date();
                 var hoy = f.getDate() + "/" + (f.getMonth() + 1) + "/" + f.getFullYear()
                 function convertirDateTimePicker() {
                    $('.date-range-picker-double-Top').daterangepicker({
                       "singleDatePicker": false,
                       "minDate": hoy.toString(),
                       "opens": "center",
                       "showDropdowns": false,
                       "autoApply": true,
                       "locale": {
                          "format": "DD/MM/YYYY",
                          "separator": " - ",
                          "customRangeLabel": "Personaliza",
                          "daysOfWeek": [
                             "Do",
                             "Lu",
                             "Ma",
                             "Mi",
                             "Ju",
                             "Vi",
                             "Sa"
                          ],
                          "monthNames": [
                             "Ene",
                             "Feb",
                             "Mar",
                             "Abr",
                             "May",
                             "Jun",
                             "Jul",
                             "Ago",
                             "Sep",
                             "Oct",
                             "Nov",
                             "Dic"
                          ],
                          "firstDay": 1
                       },
                       "startDate": hoy.toString(),
                       "endDate": hoy.toString(),
                       "drops": "down"
                    });
                 }
                 function basicPicker() {
                    $('.date-range-picker-double-Top').daterangepicker({
                       "singleDatePicker": false,
                       "minDate": hoy.toString(),
                       "opens": "center",
                       "showDropdowns": false,
                       "autoApply": true,
                       "locale": {
                          "format": "DD/MM/YYYY",
                          "separator": " - ",
                          "customRangeLabel": "Personaliza",
                          "daysOfWeek": [
                             "Do",
                             "Lu",
                             "Ma",
                             "Mi",
                             "Ju",
                             "Vi",
                             "Sa"
                          ],
                          "monthNames": [
                             "Ene",
                             "Feb",
                             "Mar",
                             "Abr",
                             "May",
                             "Jun",
                             "Jul",
                             "Ago",
                             "Sep",
                             "Oct",
                             "Nov",
                             "Dic"
                          ],
                          "firstDay": 1
                       },
                       "drops": "down"
                    });
                 }
                 function dateSinglePicker() {
                    $('.date-single-picker').daterangepicker({
                       "singleDatePicker": true,
                       "minDate": hoy.toString(),
                       "opens": "center",
                       "showDropdowns": false,
                       "autoApply": true,
                       "locale": {
                          "format": "DD/MM/YYYY",
                          "separator": " - ",
                          "customRangeLabel": "Personaliza",
                          "daysOfWeek": [
                             "Do",
                             "Lu",
                             "Ma",
                             "Mi",
                             "Ju",
                             "Vi",
                             "Sa"
                          ],
                          "monthNames": [
                             "Ene",
                             "Feb",
                             "Mar",
                             "Abr",
                             "May",
                             "Jun",
                             "Jul",
                             "Ago",
                             "Sep",
                             "Oct",
                             "Nov",
                             "Dic"
                          ],
                          "firstDay": 1
                       },
                       "drops": "down"
                    });
                 }
    </script>
  </body>
</html>
