<%-- 
    Document   : man_recuperacion
    Created on : 31-ago-2018, 9:06:38
    Author     : Felipe Escala
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@ include file="validar.jsp" %>
<!DOCTYPE html>
<html>
  <head>
    <!-- START @META SECTION -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
    <meta name="description" content="Blankon is a theme fullpack admin template powered by Twitter bootstrap 3 front-end framework. Included are multiple example pages, elements styles, and javascript widgets to get your project started.">
    <meta name="keywords" content="admin, admin template, bootstrap3, clean, fontawesome4, good documentation, lightweight admin, responsive dashboard, webapp">
    <meta name="author" content="Djava UI">
    <title>SISTEMA CUOTAS PAGO ACADEMIA</title>
    <link rel="icon" type="image/png" sizes="16x16" href="images/helicoide.png" />
    <!-- START @FONT STYLES -->
    <link href="http://fonts.googleapis.com/css?family=Open+Sans:400,300,600,700" rel="stylesheet">
    <link href="http://fonts.googleapis.com/css?family=Oswald:700,400" rel="stylesheet">
    <!--/ END FONT STYLES -->

    <!-- START @GLOBAL MANDATORY STYLES -->
    <link href="../limitless/assets/css/icons/icomoon/styles.css" rel="stylesheet" type="text/css">
    <!--<link href="../limitless/assets/css/components.css" rel="stylesheet" type="text/css">-->
    <link href="../assets/global/plugins/bower_components/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">
    <link href="../assets/global/plugins/bower_components/bootstrap-switch/dist/css/bootstrap3/bootstrap-switch.min.css" rel="stylesheet">
    <!--/ END GLOBAL MANDATORY STYLES -->

    <!-- START @PAGE LEVEL STYLES -->
    <link href="../assets/global/plugins/bower_components/fontawesome/css/font-awesome.min.css" rel="stylesheet">
    <link href="../assets/global/plugins/bower_components/animate.css/animate.min.css" rel="stylesheet">
    <link href="../assets/global/plugins/bower_components/dropzone/downloads/css/dropzone.css" rel="stylesheet">
    <link href="../assets/global/plugins/bower_components/jquery.gritter/css/jquery.gritter.css" rel="stylesheet">
    <!--/ END PAGE LEVEL STYLES -->

    <!-- DATEPICKER CSS INICIO -->
    <link href="../assets/global/plugins/bower_components/bootstrap-daterangepicker/daterangepicker.css" rel="stylesheet">
    <!-- DATEPICKER CSS FINAL -->

    <!-- START @THEME STYLES -->


    <link href="../assets/admin/css/reset.css" rel="stylesheet">
    <link href="../assets/admin/css/layout.css" rel="stylesheet">
    <link href="../assets/admin/css/components.css" rel="stylesheet">
    <!--<link href="../assets/admin/css/plugins.css" rel="stylesheet">-->
    <link href="../assets/admin/css/themes/red.theme.css" rel="stylesheet" id="theme">
    <link href="../assets/admin/css/custom.css" rel="stylesheet">
    <link rel="stylesheet" href="validar/css/validationEngine.jquery.css" type="text/css"/>
    <link href="../css/pages/select2.css" rel="stylesheet" type="text/css"/>
    <link href="../css/datatables.css" rel="stylesheet" type="text/css"/>
    <link href="../css/pages/general.css" rel="stylesheet" type="text/css"/>
    <style>
      .btn-slate {
        color: #FFF;
        background-color: #607D8C;
        border-color: #586c76;
        text-shadow: 0 -1px 0 rgba(0, 0, 0, 0.1);
      }
      .panel>.table-responsive {
        margin-bottom: -20px;
        border: 0;
      }
      table.dataTable.stripe tbody tr.odd, table.dataTable.display tbody tr.odd {
        background-color: #ffffff; 
      }
      table.dataTable.no-footer {
        border-bottom: none;
      }
      table.dataTable tbody th, table.dataTable tbody td {
        padding: 5px 10px;
      }      
      table.dataTable thead th, table.dataTable thead td {
        padding: 5px 10px;
        border-bottom: 1px #DDDDDD solid;
      }      
      .datepicker{z-index:9999 !important}
      .daterangepicker{z-index:9999 !important}
      .bg-darkBlue {
        background-color: #2D72AD !important;
        border: 1px solid #2D72AD;
        color: white;
      }
      form .form-group .error {
        display: block;
        font-style: initial ;
      }
      .modal-md {
        width: 400px;
      }
    </style>
  </head>
  <body class="page-sound page-header-fixed page-sidebar-fixed" onload="cargar();">
    <section id="wrapper">
      <%@ include file="banner.jsp" %>
      <input id="codTitulo" type="hidden" value='<%=menu != null ? menu.getCodigoTitulo() : ""%>'>
      <input id="codModulo" type="hidden" value='<%=menu != null ? menu.getCodigoModulo() : ""%>'>
      <input id="codCategoria" type="hidden" value='<%=menu != null ? menu.getCodigoCategoria() : ""%>'>
      <input id="codSubCategoria" type="hidden" value='<%=menu != null ? menu.getCodigoSubCategoria() : ""%>'>
      <%@ include file="menu.jsp" %>
      <section id="page-content">


        <div class="header-content">
          <h2><i class="fa fa-cogs"></i>Asistencia <span>Mantenimiento de Recuperaciones</span></h2>
          <div class="breadcrumb-wrapper hidden-xs">
          </div>
        </div>


        <div class="body-content animated fadeIn">
          <div class="row">

            <div class="col-md-4 col-md-offset-4">
              <div class="panel rounded shadow panel-blueDark panelborder">
                <div class="panel-heading ">
                  <div class="pull-left">
                    <h3 class="panel-title"><i class="fa fa-search"></i>Búsqueda de Recuperaciones</h3>
                  </div>
                  <div class="clearfix"></div>
                </div>
                <div class="panel-body no-padding">
                  <form id="formBusqueda" onsubmit="return false;" autocomplete="off">
                    <div class="form-body">
                      <fieldset>
                        <div class="form-group col-md-6" id="txtFiltroTipo">
                          <label class="control-label"><b>Buscar por<span class="asterisk">&nbsp;(*)</span></b></label>
                          <select class="form-control" id="cboTipoFiltro">
                            <option value="1">Ciclo</option>
                            <option value="2">Fecha</option>
                          </select>
                        </div>
                        <div class="form-group col-md-6" id="colCiclo">
                          <label class="control-label"><b>Ciclo<span class="asterisk">&nbsp;(*)</span></b></label>                                                    
                          <select class="form-control cboCiclo" id="cboCicloBusqueda" name="cboCicloBusqueda">
                            <option value="">[SELECCIONE]</option>
                          </select>
                        </div>
                        <div class="form-group col-md-6 hide" id="colFecha">
                          <label class="control-label"><b>Fecha<span class="asterisk">&nbsp;(*)</span></b></label>                                                    
                          <input type="text" class="form-control date-single-picker" id="txtFechaBusqueda" name="txtFechaBusqueda" readonly=""/>
                        </div>
                        <div class="col-md-12">
                          <div class="form-group">
                            <div class="text-right"> 
                              <span class="text-danger">(*) </span>  Campo obligatorio
                            </div>
                          </div>
                        </div>
                      </fieldset>
                    </div>
                    <div class="form-footer">
                      <div class="pull-right">
                        <button id="btnBuscar" class="btn btn-foursquare" type="button"><i class="fa fa-search"></i> BUSCAR</button>
                        <button id="btnLimpiar" class="btn btn-warning" type="button"><i class="fa fa-refresh"></i> LIMPIAR</button>
                      </div>
                      <div class="clearfix"></div>
                    </div>
                  </form>
                </div>
              </div> 
            </div>

            <div class="col-md-6 col-md-offset-3">
              <div class="panel rounded shadow panel-blueDark panelborder">
                <div class="panel-heading blue2">
                  <div class="pull-left">
                    <h3 class="panel-title"><i class="fa fa-list-alt"></i>Listado de Recuperaciones</h3>
                  </div>
                  <div class="pull-right">
                    <button id="btnNuevo"  type="button"  class="btn btn-slate"><i class="glyphicon glyphicon-plus "></i>&nbsp; Nueva Recuperacion</button>
                  </div>                                           
                  <div class="clearfix"></div>
                </div>
                <div class="table-responsive" >

                  <table class="table table-responsive table-striped table-hover table-bordered display nowrap dataTable no-footer" style ="width: 100%" id="tblRecuperaciones">                                                 
                    <thead>
                      <tr>
                        <th class="text-center">Nº</th>
                        <th class="text-center">CICLO</th>
                        <th class="text-center">FECHA</th>                                                    
                        <th class="text-center">HORA INICIO</th>
                        <th class="text-center">ACCIONES</th>                                               
                      </tr>
                    </thead>
                  </table>
                </div>
                <br>
              </div> 
            </div>
          </div>
        </div>
        <%@ include file="footer.jsp" %>
      </section>
    </section>
    <div id="registrarRecuperacion" class="modal fade" data-backdrop='static'>
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header bg-darkBlue">
            <h4 class="modal-title">Registrar Recuperacion</h4>
          </div>
          <div class="modal-body">
            <form id="formNuevo" onsubmit="return false;" autocomplete="off">
              <div class="row">
                <div class="col-md-6">
                  <div class="form-group">                                          
                    <label>Ciclo: <span class="asterisk">(*)</span></label>
                    <select class="form-control cboCiclo" id="cboCicloRegistro" name="cboCicloRegistro">
                      <option value="">[SELECCIONE]</option>
                    </select>
                  </div>
                </div>
                <div class="col-md-6">
                  <div class="form-group">
                    <label>Fecha: <span class="asterisk">(*)</span></label>
                    <input class="form-control date-single-picker" id="cboFechaRegistro" name="cboFechaRegistro" type="text" readonly=""/>
                  </div>
                </div>
              </div>
              <div class="row">
                <div class="col-md-6">
                  <div class="form-group">
                    <label>Hora Inicio: <span class="asterisk">(*)</span></label>
                    <input class="form-control" type="time" id="txtInicioRegistro" name="txtInicioRegistro" >
                  </div>
                </div>
                <div class="col-md-6">
                  <div class="form-group">
                    <label> Hora Fin: <span class="asterisk">(*)</span></label>
                    <input class="form-control" type="time" id="txtFinRegistro" name="txtFinRegistro" >
                  </div>
                </div>
                <div class="col-md-12">
                  <div class="form-group">
                    <div class="text-right"> 
                      <span class="text-danger">(*) </span>  Campo obligatorio
                    </div>
                  </div>
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button type="button" id="btnAgregarRecuperacion" class="btn btn-success">Crear</button>
            <button type="button" class="btn btn-danger" id="btnCancelarRegistro">Cancelar</button>
          </div>
        </div>
      </div>
    </div>
    <div id="editarRecuperaciones" class="modal fade" data-backdrop='static'>
      <div class="modal-dialog modal-md">
        <div class="modal-content">
          <div class="modal-header bg-darkBlue">
            <h4 class="modal-title">Editar Recuperaciones</h4>
          </div>
          <div class="modal-body">
            <form id="formEditar" onsubmit="return false" autocomplete="off">
              <div class="row">
                <div class="col-md-12">
                  <div class="form-group">
                    <h5>
                      <i class="fa fa-user" id="dataUser"></i>
                      <input type="hidden" id="codigoRecuperacion">
                    </h5>
                  </div>
                </div>
                <div class="col-md-12">
                  <div class="form-group">
                    <label>Fecha: <span class="asterisk">(*)</span></label>
                    <input class="form-control date-single-picker" id="cboFechaEdicion" name="cboFechaEdicion" type="text" readonly=""/>
                  </div>
                </div>
              </div>
              <div class="row">
                <div class="col-md-6">
                  <div class="form-group">
                    <label>Hora Inicio: <span class="asterisk">(*)</span></label>
                    <input class="form-control" type="time" id="txtInicioEdicion" name="txtInicioEdicion" >
                  </div>
                </div>
                <div class="col-md-6">
                  <div class="form-group">
                    <label> Hora Fin: <span class="asterisk">(*)</span></label>
                    <input class="form-control" type="time" id="txtFinEdicion" name="txtFinEdicion" >
                  </div>
                </div>
                <div class="col-md-12">
                  <div class="form-group">
                    <div class="text-right"> 
                      <span class="text-danger">(*) </span>  Campo obligatorio
                    </div>
                  </div>
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button type="button" id="btnEditarRecuperacion" class="btn btn-success">Editar</button>
            <button type="button" class="btn btn-danger" id="btnCancelarEdicion">Cancelar</button>
          </div>
        </div>
      </div>
    </div>

    <div id="back-top" class="animated pulse circle">
      <i class="fa fa-angle-up"></i>
    </div>
    <!-- START JAVASCRIPT SECTION (Load javascripts at bottom to reduce load time) -->
    <!-- START @CORE PLUGINS -->
    <script src="../assets/global/plugins/bower_components/jquery/dist/jquery.min.js"></script>
    <script src="../assets/global/plugins/bower_components/jquery-cookie/jquery.cookie.js"></script>
    <script src="../assets/global/plugins/bower_components/bootstrap/dist/js/bootstrap.min.js"></script>
    <script src="../assets/global/plugins/bower_components/typehead.js/dist/handlebars.js"></script>
    <script src="../assets/global/plugins/bower_components/typehead.js/dist/typeahead.bundle.min.js"></script>
    <script src="../assets/global/plugins/bower_components/jquery-nicescroll/jquery.nicescroll.min.js"></script>
    <script src="../assets/global/plugins/bower_components/jquery.sparkline.min/index.js"></script>
    <script src="../assets/global/plugins/bower_components/jquery-easing-original/jquery.easing.1.3.min.js"></script>
    <script src="../assets/global/plugins/bower_components/ionsound/js/ion.sound.min.js"></script>
    <script src="../assets/global/plugins/bower_components/bootbox/bootbox.js"></script>
    <!--/ END CORE PLUGINS -->

    <!-- START @PAGE LEVEL PLUGINS -->
    <!--<script src="../assets/global/plugins/bower_components/bootstrap-session-timeout/dist/bootstrap-session-timeout.min.js"></script>-->
    <script src="../assets/global/plugins/bower_components/flot/jquery.flot.js"></script>
    <script src="../assets/global/plugins/bower_components/flot/jquery.flot.spline.min.js"></script>
    <script src="../assets/global/plugins/bower_components/flot/jquery.flot.categories.js"></script>
    <script src="../assets/global/plugins/bower_components/flot/jquery.flot.tooltip.min.js"></script>
    <script src="../assets/global/plugins/bower_components/flot/jquery.flot.resize.js"></script>
    <script src="../assets/global/plugins/bower_components/flot/jquery.flot.pie.js"></script>
    <script src="../assets/global/plugins/bower_components/dropzone/downloads/dropzone.min.js"></script>
    <script src="../assets/global/plugins/bower_components/jquery.gritter/js/jquery.gritter.min.js"></script>
    <script src="../assets/global/plugins/bower_components/skycons-html5/skycons.js"></script>
    <!--/ END PAGE LEVEL PLUGINS -->

    <!-- DATEPICKER JS INICIO -->
    <script src="../assets/global/plugins/bower_components/moment/min/moment.min.js"></script>
    <script src="../assets/global/plugins/bower_components/bootstrap-daterangepicker/daterangepicker.js"></script>
    <script src="../limitless/assets/js/plugins/forms/validation/validate.min.js" type="text/javascript"></script>
    <!-- DATEPICKER JS FINAL -->

    <!-- START @PAGE LEVEL SCRIPTS -->
    <script src="../assets/admin/js/apps.js"></script>
    <script src="../assets/admin/js/pages/blankon.dashboard.js"></script>
    <script src="../assets/plugin/datatables.min.js" type="text/javascript"></script>
    <script src="../assets/plugin/bootbox.min.js" type="text/javascript"></script>
    <script src="../assets/plugin/validateAlfi.js" type="text/javascript"></script>     
    <script src="../assets/plugin/select2.min.js" type="text/javascript"></script>
    <script src="../js/general.js" type="text/javascript"></script>
    <script type="text/javascript">
                 segundaCarga = () => {
                    initComponents.init()
                    DOMEvents.init()
                    initRequest.init()
                    initPickers.init()
                 }

                 const helpers = {
                    tblCharge() {
                       tableRecuperaciones.destroy()
                       initComponents.listarRecuperaciones()
                    },
                    tblRefresh() {
                       tableRecuperaciones.ajax.reload(null, false);
                    }
                 }

                 const httpRequest = {
                    listarCiclos(json) {
                       return new Promise((resolve, reject) => {
                          $.ajax({
                             type: 'POST',
                             url: "../ServletRecuperacion?accion=listarCiclos",
                             dataType: "json",
                             data: {
                                json: JSON.stringify(json)
                             },
                             success: function (data, textStatus, jqXHR) {
                                resolve(data)
                             }, error: function (jqXHR, textStatus, errorThrown) {
                                reject('Error en la petición')
                             }
                          })
                       })
                    },
                    registrarRecuperacion(json) {
                       return new Promise((resolve, reject) => {
                          $.ajax({
                             type: 'POST',
                             url: "../ServletRecuperacion?accion=nuevaRecuperacion",
                             dataType: "json",
                             data: {
                                json: JSON.stringify(json)
                             },
                             success: function (data, textStatus, jqXHR) {
                                resolve(data)
                             }, error: function (jqXHR, textStatus, errorThrown) {
                                reject('Error en la petición')
                             }
                          })
                       })
                    },
                    eliminarRecuperacion(json) {
                       return new Promise((resolve, reject) => {
                          $.ajax({
                             type: 'POST',
                             url: "../ServletRecuperacion?accion=eliminarRecuperacion",
                             dataType: "json",
                             data: {
                                json: JSON.stringify(json)
                             },
                             success: function (data, textStatus, jqXHR) {
                                resolve(data)
                             }, error: function (jqXHR, textStatus, errorThrown) {
                                reject('Error en la petición')
                             }
                          })
                       })
                    },
                    editarRecuperacion(json) {
                       return new Promise((resolve, reject) => {
                          $.ajax({
                             type: 'POST',
                             url: "../ServletRecuperacion?accion=editarRecuperacion",
                             dataType: "json",
                             data: {
                                json: JSON.stringify(json)
                             },
                             success: function (data, textStatus, jqXHR) {
                                resolve(data)
                             }, error: function (jqXHR, textStatus, errorThrown) {
                                reject('Error en la petición')
                             }
                          })
                       })
                    }
                 }

                 const DOMEvents = {
                    init() {
                       this.resetBusqueda()
                       this.abrirModalRegistro()
                       this.registrarRecuperacion()
                       this.buscarRecuperaciones()
                       this.cancelarRegistro()
                       this.eliminarRecuperacion()
                       this.abrirModalEdicion()
                       this.cancelarEdicion()
                       this.checkSelects()
                       this.editarRecuperacion()
                    },
                    resetBusqueda() {
                       $('#btnLimpiar').click(() => {
                          $('#formBusqueda').trigger("reset");
                          $('#cboTipoFiltro').change()
                          helpers.tblCharge()
                       })
                    },
                    cancelarRegistro() {
                       $('#btnCancelarRegistro').click(() => {
                          $('#registrarRecuperacion').modal('hide')
                          $('#formNuevo').trigger("reset")
                       })
                    },
                    cancelarEdicion() {
                       $('#btnCancelarEdicion').click(() => {
                          $('#editarRecuperaciones').modal('hide')
                          $('#formEditar').trigger("reset");
                       })
                    },
                    buscarRecuperaciones() {
                       $('#btnBuscar').click(() => {
                          var valBusqueda = $("#formBusqueda").validate({
                             rules: {
                                txtFechaBusqueda: {required: true},
                                cboCicloBusqueda: {required: true}
                             },
                             messages: {
                                txtFechaBusqueda: {required: "<b>&times;</b>&nbsp;Este campo es requerido"},
                                cboCicloBusqueda: {required: "<b>&times;</b>&nbsp;Este campo es requerido"}
                             }
                          });
                          if (valBusqueda.form()) {
                             helpers.tblCharge()
                          }
                       })
                    },
                    abrirModalRegistro() {
                       $('#btnNuevo').click(() => {
                          $('#registrarRecuperacion').modal('show')
                       })
                    },
                    registrarRecuperacion() {
                       $('#btnAgregarRecuperacion').click(() => {
                          var valRegistroRecuperacion = $("#formNuevo").validate({
                             rules: {
                                cboCicloRegistro: {required: true},
                                cboFechaRegistro: {required: true},
                                txtFinRegistro:
                                        {
                                           required: true,
                                           higherThan: 'txtInicioRegistro'
                                        },
                                txtInicioRegistro: {required: true}
                             },
                             messages: {
                                cboCicloRegistro: {required: "<b>&times;</b>&nbsp;Este campo es requerido"},
                                cboFechaRegistro: {required: "<b>&times;</b>&nbsp;Este campo es requerido"},
                                txtFinRegistro: {required: "<b>&times;</b>&nbsp;Este campo es requerido"},
                                txtInicioRegistro: {required: "<b>&times;</b>&nbsp;Este campo es requerido"}
                             }
                          });
                          if (valRegistroRecuperacion.form()) {
                             httpRequest.registrarRecuperacion({
                                'codigoCiclo': $('#cboCicloRegistro').val(),
                                'fechaRecuperacion': $('#cboFechaRegistro').val(),
                                'inicioRecuperacion': $('#txtInicioRegistro').val(),
                                'finRecuperacion': $('#txtFinRegistro').val()
                             })
                                     .then((data) => {
                                        if (data.status) {
                                           $('#registrarRecuperacion').modal('hide')
                                           msnSuccess("Recuperacion agregado correctamente", () => {
                                              $('#formNuevo').trigger("reset")
                                              helpers.tblRefresh()
                                           })
                                        } else {
                                           if ((data.message).includes('--->')) {
                                              $('#registrarRecuperacion').modal('hide')
                                              msnError("Ha ocurrido un error", () => {
                                                 $('#registrarRecuperacion').modal('show')
                                              })
                                           } else {
                                              $('#registrarRecuperacion').modal('hide')
                                              msnError(data.message, () => {
                                                 $('#registrarRecuperacion').modal('show')
                                              })
                                           }
                                        }
                                     })
                                     .catch(err => console.log(err))
                          }
                       })
                    },
                    eliminarRecuperacion() {
                       $('#tblRecuperaciones tbody').on('click', '.eliminar', (e) => {
                          let thisNode = e.currentTarget;
                          let data = tableRecuperaciones.row($(thisNode).parents('tr')).data();
                          msnConfirm(`<label>¿Seguro de eliminar esta Recuperacion?</label>`, (option) => {
                             if (option) {
                                httpRequest.eliminarRecuperacion(data)
                                        .then((data) => {
                                           if (data.status) {
                                              helpers.tblRefresh()
                                              msnSuccess("Recuperacion correctamente eliminada")
                                           } else {
                                              if ((data.message).includes('--->')) {
                                                 msnError("Ha ocurrido un error")
                                              } else {
                                                 msnError(data.message)
                                              }
                                           }
                                        })
                                        .catch(err => console.log(err))
                             }
                          });
                       })
                    },
                    abrirModalEdicion() {
                       $('#tblRecuperaciones tbody').on('click', '.editar', (e) => {
                          let thisNode = e.currentTarget;
                          let data = tableRecuperaciones.row($(thisNode).parents('tr')).data();
                          $('#editarRecuperaciones').modal('show')
                          $('#dataUser').text(" " + data.nombreCiclo)
                          $('#cboFechaEdicion').val(data.fechaRecuperacion)
                          initPickers.singlePicker()
                          $('#txtInicioEdicion').val(data.inicioRecuperacion)
                          $('#txtFinEdicion').val(data.finRecuperacion)
                          $('#codigoRecuperacion').val(data.codigoRecuperacion)
                       })
                    },
                    editarRecuperacion() {
                       $('#btnEditarRecuperacion').click(() => {
                          var valRegistroRecuperacion = $("#formEditar").validate({
                             rules: {
                                cboFechaEdicion: {required: true},
                                txtInicioEdicion: {required: true},
                                txtFinEdicion:
                                        {
                                           required: true,
                                           higherThan: 'txtInicioEdicion'
                                        }
                             },
                             messages: {
                                cboFechaEdicion: {required: "<b>&times;</b>&nbsp;Este campo es requerido"},
                                txtInicioEdicion: {required: "<b>&times;</b>&nbsp;Este campo es requerido"},
                                txtFinEdicion: {required: "<b>&times;</b>&nbsp;Este campo es requerido"}
                             }
                          });
                          if (valRegistroRecuperacion.form()) {
                             httpRequest.editarRecuperacion({
                                'fechaRecuperacion': $('#cboFechaEdicion').val(),
                                'inicioRecuperacion': $('#txtInicioEdicion').val(),
                                'finRecuperacion': $('#txtFinEdicion').val(),
                                'codigoRecuperacion': $('#codigoRecuperacion').val()
                             })
                                     .then((data) => {
                                        if (data.status) {
                                           $('#editarRecuperaciones').modal('hide')
                                           helpers.tblRefresh()
                                           msnSuccess("Recuperacion correctamente editado", () => {
                                              $('#formEditar').trigger("reset");
                                           })
                                        } else {
                                           if ((data.message).includes('--->')) {
                                              $('#editarRecuperaciones').modal('hide')
                                              msnError("Ha ocurrido un error", () => {
                                                 $('#editarRecuperaciones').modal('show')
                                              })
                                           } else {
                                              $('#editarRecuperaciones').modal('hide')
                                              msnError(data.message, () => {
                                                 $('#editarRecuperaciones').modal('show')
                                              })
                                           }
                                        }
                                     })
                                     .catch(err => console.log(err))
                          }
                       }
                       )
                    },
                    checkSelects() {
                       $('#cboTipoFiltro').change((e) => {
                          _this = e.currentTarget
                          if (_this.value === '1') {
                             $('#colCiclo').removeClass('hide')
                             $('#colFecha').addClass('hide')
                          } else if (_this.value === '2') {
                             $('#colCiclo').addClass('hide')
                             $('#colFecha').removeClass('hide')
                          }
                       })
                    }
                 }

                 const initRequest = {
                    init() {
                       this.cargarLista()
                    },
                    cargarLista() {
                       httpRequest.listarCiclos(json)
                               .then((data) => {
                                  if (data.status) {
                                     var lista = data.results;
                                     var print = " <option value=''>[SELECCIONE]</option> ";
                                     for (var i in lista) {
                                        print += " <option value ='" + lista[i].codigoCiclo + "'>" + capitalizeWords(lista[i].nombreCiclo) + "</option> ";
                                     }
                                     $(".cboCiclo").html(print);
                                  } else {
                                     var print = " <option value=''>No hay contenido</option> ";
                                     $(".cboCiclo").html(print);
                                  }
                               })
                               .catch(err => console.log(err))
                    }
                 }

                 const initComponents = {
                    init() {
                       this.listarRecuperaciones()
                    },
                    listarRecuperaciones() {
                       json = {}
                       if ($('#cboTipoFiltro').val() === '1' && $('#cboCicloBusqueda').val() !== '') {
                          json.codigoAula = $('#cboCicloBusqueda').val()
                       } else if ($('#cboTipoFiltro').val() === '2' && $('#txtFechaBusqueda').val() !== '') {
                          json.fechaRecuperacion = $('#txtFechaBusqueda').val()
                       }
                       tableRecuperaciones = $("#tblRecuperaciones").DataTable({
                          "language": {
                             "lengthMenu": "Mostrar: _MENU_",
                             "zeroRecords": "&nbsp;&nbsp;&nbsp; No se encontraron resultados",
                             "info": "&nbsp;&nbsp;&nbsp; Mostrando del _START_ al _END_ de un total de _TOTAL_ registros",
                             "infoEmpty": "&nbsp;&nbsp;&nbsp; Mostrando 0 de 0 registros",
                             "search": "Filtrar:",
                             "loadingRecords": "Cargando...",
                             "processing": '<span style="width:100%;"><img src="../../img/ajax-loader-img.gif" alt=""/></span>',
                             "paginate": {
                                "first": "First",
                                "last": "Last",
                                "next": "Siguiente",
                                "previous": "Anterior"
                             }
                          },
                          dom: '<"datatable-scroll"t>r<"datatable-footers"ip>',
                          ajax: {
                             type: 'POST',
                             url: "../ServletRecuperacion?accion=listarRecuperaciones",
                             data: {
                                json: JSON.stringify(json)
                             }
                          },
                          "bSort": false,
                          "bFilter": false,
                          "serverSide": true,
                          "processing": true,
                          "aaSorting": [],
                          "ordering": false,
                          "bLengthChange": false,
                          "bInfo": true,
                          "paging": true,
                          "iDisplayLength": 15,
                          "columnDefs": [
                             {targets: 0, orderable: false, width: "5%", className: "text-center"},
                             {targets: 1, orderable: false, width: "20%"},
                             {targets: 2, orderable: false, width: "10%", className: "text-center"},
                             {targets: 3, orderable: false, width: "10%", className: "text-center"},
                             {targets: 4, orderable: false, width: "10%", className: "text-center"}
                          ],
                          "columns": [
                             {"data": "numeral"},
                             {"data": null, "render": (data, type, row) => {
                                   return capitalizeWords(row.nombreCiclo);
                                }
                             },
                             {"data": "fechaRecuperacion"},
                             {"data": "inicioRecuperacion"},
                             {"data": null, "render": (data, type, row) => {
                                   return `<span class='editar'><i class="fa fa-pencil bigger-140 blue"></i>&nbsp;&nbsp;</span>
                                                                     <span class='eliminar'><i class="fa fa-trash-o bigger-140 red"></i>&nbsp;&nbsp;</span>`
                                }
                             }
                          ]
                       });
                    }
                 }

                 var f = new Date();
                 var hoy = f.getDate() + "/" + (f.getMonth() + 1) + "/" + f.getFullYear()

                 const initPickers = {
                    init() {
                       this.rangePicker()
                       this.singlePicker()
                    },
                    rangePicker() {
                       $('.date-range-picker').daterangepicker({
                          "singleDatePicker": false,
                          "minDate": hoy.toString(),
                          "opens": "center",
                          "showDropdowns": false,
                          "autoApply": true,
                          "locale": {
                             "format": "DD/MM/YYYY",
                             "separator": " - ",
                             "customRangeLabel": "Personaliza",
                             "daysOfWeek": [
                                "Do",
                                "Lu",
                                "Ma",
                                "Mi",
                                "Ju",
                                "Vi",
                                "Sa"
                             ],
                             "monthNames": [
                                "Ene",
                                "Feb",
                                "Mar",
                                "Abr",
                                "May",
                                "Jun",
                                "Jul",
                                "Ago",
                                "Sep",
                                "Oct",
                                "Nov",
                                "Dic"
                             ],
                             "firstDay": 1
                          },
                          "drops": "down"
                       });
                    },
                    singlePicker() {
                       $('.date-single-picker').daterangepicker({
                          "singleDatePicker": true,
                          "minDate": hoy.toString(),
                          "opens": "center",
                          "showDropdowns": false,
                          "autoApply": true,
                          "locale": {
                             "format": "DD/MM/YYYY",
                             "separator": " - ",
                             "customRangeLabel": "Personaliza",
                             "daysOfWeek": [
                                "Do",
                                "Lu",
                                "Ma",
                                "Mi",
                                "Ju",
                                "Vi",
                                "Sa"
                             ],
                             "monthNames": [
                                "Ene",
                                "Feb",
                                "Mar",
                                "Abr",
                                "May",
                                "Jun",
                                "Jul",
                                "Ago",
                                "Sep",
                                "Oct",
                                "Nov",
                                "Dic"
                             ],
                             "firstDay": 1
                          },
                          "drops": "down"
                       });
                    }
                 }
    </script>
  </body>
</html>