/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.academia.Services;

import org.json.JSONObject;
import pe.siso.academia.DAO.AsistenciaDAO;
import pe.siso.academia.DAO.DAOFactory;

/**
 *
 * @author Felipe Escala
 */
public class AsistenciaService {

	DAOFactory fabrica = DAOFactory.getDAOFactory(DAOFactory.MYSQL);
	AsistenciaDAO dao = fabrica.getAsistenciaDAO();

	public JSONObject listarAsistencia(JSONObject datos) {
		JSONObject obj = null;
		try {
			obj = dao.listarAsistencia(datos);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return obj;
	}

	public JSONObject editarAsistencias(JSONObject datos) {
		JSONObject obj = null;
		try {
			obj = dao.editarAsistencias(datos);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return obj;
	}

	public JSONObject registrarAsistencia(JSONObject datos) {
		JSONObject obj = null;
		try {
			obj = dao.registrarAsistencia(datos);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return obj;
	}

	public JSONObject eliminarAsistencia(JSONObject datos) {
		JSONObject obj = null;
		try {
			obj = dao.eliminarAsistencia(datos);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return obj;
	}

	public JSONObject listarCicloPorEstudiante(JSONObject datos) {
		JSONObject obj = null;
		try {
			obj = dao.listarCicloPorEstudiante(datos);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return obj;
	}

	public JSONObject listarEstudiantesPorCiclo(JSONObject datos) {
		JSONObject obj = null;
		try {
			obj = dao.listarEstudiantesPorCiclo(datos);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return obj;
	}

	public JSONObject listarClasesPorCiclo(JSONObject datos) {
		JSONObject obj = null;
		try {
			obj = dao.listarClasesPorCiclo(datos);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return obj;
	}
}
