  <%-- 
    Document   : man_asistencia
    Created on : 31-ago-2018, 9:06:51
    Author     : Felipe Escala
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@ include file="validar.jsp" %>
<!DOCTYPE html>
<html>
  <head>
    <!-- START @META SECTION -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
    <meta name="description" content="Blankon is a theme fullpack admin template powered by Twitter bootstrap 3 front-end framework. Included are multiple example pages, elements styles, and javascript widgets to get your project started.">
    <meta name="keywords" content="admin, admin template, bootstrap3, clean, fontawesome4, good documentation, lightweight admin, responsive dashboard, webapp">
    <meta name="author" content="Djava UI">
    <title>SISTEMA CUOTAS PAGO ACADEMIA</title>
    <link rel="icon" type="image/png" sizes="16x16" href="images/helicoide.png" />
    <!-- START @FONT STYLES -->

    <link href="../limitless/assets/css/components.css" rel="stylesheet" type="text/css">
    <link href="http://fonts.googleapis.com/css?family=Open+Sans:400,300,600,700" rel="stylesheet">
    <link href="http://fonts.googleapis.com/css?family=Oswald:700,400" rel="stylesheet">
    <!--/ END FONT STYLES -->

    <!-- START @GLOBAL MANDATORY STYLES -->
    <link href="../limitless/assets/css/icons/icomoon/styles.css" rel="stylesheet" type="text/css">
    <link href="../assets/global/plugins/bower_components/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">
    <link href="../assets/global/plugins/bower_components/bootstrap-switch/dist/css/bootstrap3/bootstrap-switch.min.css" rel="stylesheet">
    <!--/ END GLOBAL MANDATORY STYLES -->

    <!-- START @PAGE LEVEL STYLES -->
    <link href="../assets/global/plugins/bower_components/fontawesome/css/font-awesome.min.css" rel="stylesheet">
    <link href="../assets/global/plugins/bower_components/animate.css/animate.min.css" rel="stylesheet">
    <link href="../assets/global/plugins/bower_components/dropzone/downloads/css/dropzone.css" rel="stylesheet">
    <link href="../assets/global/plugins/bower_components/jquery.gritter/css/jquery.gritter.css" rel="stylesheet">
    <!--/ END PAGE LEVEL STYLES -->

    <!-- DATEPICKER CSS INICIO -->
    <link href="../assets/global/plugins/bower_components/bootstrap-daterangepicker/daterangepicker.css" rel="stylesheet">
    <!-- DATEPICKER CSS FINAL -->

    <!-- START @THEME STYLES -->


    <link href="../assets/admin/css/reset.css" rel="stylesheet">
    <link href="../assets/admin/css/layout.css" rel="stylesheet">
    <link href="../assets/admin/css/components.css" rel="stylesheet">
    <link href="../assets/admin/css/themes/red.theme.css" rel="stylesheet" id="theme">
    <link href="../assets/admin/css/custom.css" rel="stylesheet">
    <link rel="stylesheet" href="validar/css/validationEngine.jquery.css" type="text/css"/>
    <link href="../css/pages/select2.css" rel="stylesheet" type="text/css"/>
    <link href="../css/datatables.css" rel="stylesheet" type="text/css"/>
    <link href="../css/pages/general.css" rel="stylesheet" type="text/css"/>
    <style>
      .btn-slate {
        color: #FFF;
        background-color: #607D8C;
        border-color: #586c76;
        text-shadow: 0 -1px 0 rgba(0, 0, 0, 0.1);
      }
      .panel>.table-responsive {
        margin-bottom: -20px;
        border: 0;
      }
      table.dataTable.stripe tbody tr.odd, table.dataTable.display tbody tr.odd {
        background-color: #ffffff; 
      }
      table.dataTable.no-footer {
        border-bottom: none;
      }
      table.dataTable tbody th, table.dataTable tbody td {
        padding: 5px 10px;
      }      
      table.dataTable thead th, table.dataTable thead td {
        padding: 5px 5px;
        border-bottom: 1px #DDDDDD solid;
      }      
      .datepicker{z-index:9999 !important}
      .daterangepicker{z-index:9999 !important}
      .bg-darkBlue {
        background-color: #2D72AD !important;
        border: 1px solid #2D72AD;
        color: white;
      }
      form .form-group .error {
        display: block;
        font-style: initial ;
      }
      .modal-md {
        width: 400px;
      }
      .btn {
        text-align: justify; 
      }
      .caret {
        display: none;
      }
    </style>
  </head>
  <body class="page-sound page-header-fixed page-sidebar-fixed" onload="cargar();">
    <section id="wrapper">
      <%@ include file="banner.jsp" %>
      <input id="codTitulo" type="hidden" value='<%=menu != null ? menu.getCodigoTitulo() : ""%>'>
      <input id="codModulo" type="hidden" value='<%=menu != null ? menu.getCodigoModulo() : ""%>'>
      <input id="codCategoria" type="hidden" value='<%=menu != null ? menu.getCodigoCategoria() : ""%>'>
      <input id="codSubCategoria" type="hidden" value='<%=menu != null ? menu.getCodigoSubCategoria() : ""%>'>
      <%@ include file="menu.jsp" %>
      <section id="page-content">


        <div class="header-content">
          <h2><i class="fa fa-cogs"></i>Asistencia <span>Mantenimiento de Recuperaciones</span></h2>
          <div class="breadcrumb-wrapper hidden-xs">
          </div>
        </div>


        <div class="body-content animated fadeIn">
          <div class="row">

            <div class="col-md-6 col-md-offset-3">
              <div class="panel rounded shadow panel-blueDark panelborder">
                <div class="panel-heading ">
                  <div class="pull-left">
                    <h3 class="panel-title"><i class="fa fa-search"></i>Búsqueda de Asistencias</h3>
                  </div>
                  <div class="clearfix"></div>
                </div>
                <div class="panel-body no-padding">
                  <form id="formBusqueda" onsubmit="return false;" autocomplete="off">
                    <div class="form-body">
                      <fieldset>
                        <div class="col-md-9" style="border-right: 1px inset;"> 

                          <div class='col-md-12 hide' id="div-busq-estudiante">
                            <div class="form-group">
                              <label>
                                ESTUDIANTE:
                              </label>
                              <span class="asterisk">(*)</span>
                              <select class="form-control cboEstudiante" id="cboEstudianteBusqueda" name="cboEstudianteBusqueda">
                                <option value="">[SELECCIONE]</option>
                              </select>
                            </div>
                          </div>

                          <div class='col-md-12' id="div-busq-fecha">
                            <div class="form-group">
                              <label>
                                FECHA:
                              </label>
                              <span class="asterisk">(*)</span>
                              <input class="form-control date-range-picker" id="txtFechaBusqueda" name="txtFechaBusqueda" readonly="">
                            </div>
                          </div>

                          <div class='col-md-12 hide' id="div-busq-ciclo">
                            <div class="form-group">
                              <label>
                                CICLO:
                              </label>
                              <span class="asterisk">(*)</span>
                              <select class="form-control" id="cboCicloBusqueda" name="cboCicloBusqueda">
                                <option value="">[SELECCIONE]</option>
                              </select>
                            </div>
                          </div>

                          <div class='col-md-12 hide' id="div-busq-estado">
                            <div class="form-group">
                              <label>
                                ESTADO:
                              </label>
                              <span class="asterisk">(*)</span>
                              <select name="cboEstadoBusqueda" id="cboEstadoBusqueda" class="form-control">
                                <option value="">[SELECCIONE]</option>
                                <option value="1">ASISTENCIA</option>
                                <option value="2">TARDANZA</option>
                                <option value="0">FALTA</option>
                              </select>
                            </div>
                          </div>

                          <div class="col-md-12">
                            <div class="form-group">
                              <div class="text-right"> 
                                <span class="text-danger">(*) </span>  Campo obligatorio
                              </div>
                            </div>
                          </div>

                        </div>
                        <div class="col-md-3"> 
                          <div class="col-md-12">
                            <div class="form-group">
                              <label>
                                AGREGAR FILTRO:
                              </label> 
                              <div class="multi-select-full">
                                <select class="form-control"  tabindex="1" id="cboTipoBusqueda" multiple="">
                                  <option value="div-busq-estudiante">ESTUDIANTE</option>
                                  <option value="div-busq-ciclo">CICLO</option>
                                  <option value="div-busq-fecha" selected="">FECHA</option>
                                  <option value="div-busq-estado">ESTADO</option>
                                </select>
                              </div>
                            </div>
                          </div>
                        </div>                        
                      </fieldset>
                    </div>
                    <div class="form-footer">
                      <div class="pull-right">
                        <button id="btnBuscar" class="btn btn-foursquare" type="button"><i class="fa fa-search"></i> BUSCAR</button>
                        <button id="btnLimpiar" class="btn btn-warning" type="button"><i class="fa fa-refresh"></i> LIMPIAR</button>
                      </div>
                      <div class="clearfix"></div>
                    </div>
                  </form>
                </div>
              </div> 
            </div>

            <div class="col-md-12">
              <div class="panel rounded shadow panel-blueDark panelborder">
                <div class="panel-heading blue2">
                  <div class="pull-left">
                    <h3 class="panel-title"><i class="fa fa-list-alt"></i>Listado de Asistencias</h3>
                  </div>
                  <div class="pull-right">
                    <button class="btn btn-success" id="btnExcel" type="button"><i class="fa fa-file-excel-o"></i> Generar Excel</button>
                    <button id="btnNuevo"  type="button"  class="btn btn-slate"><i class="glyphicon glyphicon-plus "></i>&nbsp; Registrar Asistencia</button>
                  </div>                                           
                  <div class="clearfix"></div>
                </div>
                <div class="table-responsive" >

                  <table class="table table-striped table-hover table-bordered display nowrap dataTable no-footer" style ="width: 100%" id="tblAsistencias">                                                 
                    <thead>
                      <tr>
                        <th class="text-center">Nº</th>
                        <th class="text-center">ESTUDIANTE</th>
                        <th class="text-center">DNI</th>
                        <th class="text-center">CICLO</th>
                        <th class="text-center">FECHA</th>
                        <th class="text-center">HORA ASISTENCIA</th>
                        <th class="text-center">HORA CLASE</th>
                        <th class="text-center">OBSERVACION</th>
                        <th class="text-center">ESTADO</th>
                        <th class="text-center">ACCIONES</th>
                      </tr>
                    </thead>
                  </table>
                </div>
                <br>
              </div> 
            </div>
          </div>
        </div>
        <%@ include file="footer.jsp" %>
      </section>
    </section>
    <div id="registrarAsistencia" class="modal fade" data-backdrop='static'>
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header bg-darkBlue">
            <h4 class="modal-title">Registrar Asistencia</h4>
          </div>
          <div class="modal-body">
            <form id="formNuevo" onsubmit="return false;" autocomplete="off">
              <div class="row"> 
                <div class="col-md-6">
                  <div class="form-group">
                    <label>Estudiante: <span class="asterisk">(*)</span></label>
                    <select class="form-control cboEstudiante" id="cboEstudianteRegistro" name="cboEstudianteRegistro">
                      <option value="">[SELECCIONE]</option>
                    </select>
                  </div>
                </div>
                <div class="col-md-6">
                  <div class="form-group">                                          
                    <label>Ciclo: <span class="asterisk">(*)</span></label>
                    <select class="form-control cboCiclo" id="cboCicloRegistro" name="cboCicloRegistro">
                      <option value="">[SELECCIONE]</option>
                    </select>
                  </div>
                </div>
              </div>
              <div class="row">
                <div class="col-md-6">
                  <div class="form-group">
                    <label>Fecha: <span class="asterisk">(*)</span></label>
                    <input class="form-control date-single-picker" id="txtFechaRegistro" name="txtFechaRegistro" readonly="">
                  </div>
                </div>
                <div class="col-md-6">
                  <div class="form-group">
                    <label> Hora: <span class="asterisk">(*)</span></label>
                    <input class="form-control" type="time" id="txtHoraRegistro" name="txtHoraRegistro" >
                  </div>
                </div>
                <div class="col-md-12">
                  <div class="form-group">
                    <label>Observaciones: <span class="asterisk">(*)</span></label>
                    <textarea class="form-control" id="taObservacionRegistro" name="taObservacionRegistro"></textarea>
                  </div>
                </div>
                <div class="col-md-12">
                  <div class="form-group">
                    <div class="text-right"> 
                      <span class="text-danger">(*) </span>  Campo obligatorio
                    </div>
                  </div>
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button type="button" id="btnAgregarAsistencia" class="btn btn-success">Crear</button>
            <button type="button" class="btn btn-danger" id="btnCancelarRegistro">Cancelar</button>
          </div>
        </div>
      </div>
    </div>
    <div id="editarAsistencia" class="modal fade" data-backdrop='static'>
      <div class="modal-dialog modal-sm">
        <div class="modal-content">
          <div class="modal-header bg-darkBlue">
            <h4 class="modal-title">Editar Asistencia</h4>
          </div>
          <div class="modal-body">
            <form id="formEditar" onsubmit="return false" autocomplete="off">
              <div class="row">
                <div class="col-md-12">
                  <div class="form-group">
                    <h5>
                      <i class="fa fa-user" id="txtEstudiante"></i>         
                    </h5>
                  </div>
                </div>
                <div class="col-md-12">
                  <div class="form-group">
                    <h5>                   
                      <i class="fa fa-calendar" id="txtAsistencia"></i>
                    </h5>
                  </div>
                </div>
                <input type="hidden" id="codigoAsistencia">
                <div class="col-md-12">
                  <div class="form-group">
                    <label>Estado: <span class="asterisk">(*)</span></label>
                    <select class="form-control" id="cboEstadoAsistencia" name="cboEstadoAsistencia" >
                      <option value="1">ASISTENCIA</option>
                      <option value="2">TARDANZA</option>
                      <option value="0">FALTA</option>
                    </select>
                  </div>
                </div>
                <div class="col-md-12">
                  <div class="form-group">
                    <label>Observaciones: <span class="asterisk">(*)</span></label>
                    <textarea class="form-control" id="taObservacionesAsistencia" name="taObservacionesAsistencia" rows="5"></textarea>
                  </div>
                </div>
                <div class="col-md-12">
                  <div class="form-group">
                    <div class="text-right"> 
                      <span class="text-danger">(*) </span>  Campo obligatorio
                    </div>
                  </div>
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button type="button" id="btnEditarAsistencia" class="btn btn-success">Editar</button>
            <button type="button" class="btn btn-danger" id="btnCancelarEdicion">Cancelar</button>
          </div>
        </div>
      </div>
    </div>

    <div id="back-top" class="animated pulse circle">
      <i class="fa fa-angle-up"></i>
    </div>
    <!-- START JAVASCRIPT SECTION (Load javascripts at bottom to reduce load time) -->
    <!-- START @CORE PLUGINS -->
    <script src="../assets/global/plugins/bower_components/jquery/dist/jquery.min.js"></script>
    <script src="../assets/global/plugins/bower_components/jquery-cookie/jquery.cookie.js"></script>
    <script src="../assets/global/plugins/bower_components/bootstrap/dist/js/bootstrap.min.js"></script>
    <script src="../assets/global/plugins/bower_components/typehead.js/dist/handlebars.js"></script>
    <script src="../assets/global/plugins/bower_components/typehead.js/dist/typeahead.bundle.min.js"></script>
    <script src="../assets/global/plugins/bower_components/jquery-nicescroll/jquery.nicescroll.min.js"></script>
    <script src="../assets/global/plugins/bower_components/jquery.sparkline.min/index.js"></script>
    <script src="../assets/global/plugins/bower_components/jquery-easing-original/jquery.easing.1.3.min.js"></script>
    <script src="../assets/global/plugins/bower_components/ionsound/js/ion.sound.min.js"></script>
    <script src="../assets/global/plugins/bower_components/bootbox/bootbox.js"></script>
    <!--/ END CORE PLUGINS -->

    <!-- START @PAGE LEVEL PLUGINS -->
    <!--<script src="../assets/global/plugins/bower_components/bootstrap-session-timeout/dist/bootstrap-session-timeout.min.js"></script>-->
    <script src="../assets/global/plugins/bower_components/flot/jquery.flot.js"></script>
    <script src="../assets/global/plugins/bower_components/flot/jquery.flot.spline.min.js"></script>
    <script src="../assets/global/plugins/bower_components/flot/jquery.flot.categories.js"></script>
    <script src="../assets/global/plugins/bower_components/flot/jquery.flot.tooltip.min.js"></script>
    <script src="../assets/global/plugins/bower_components/flot/jquery.flot.resize.js"></script>
    <script src="../assets/global/plugins/bower_components/flot/jquery.flot.pie.js"></script>
    <script src="../assets/global/plugins/bower_components/dropzone/downloads/dropzone.min.js"></script>
    <script src="../assets/global/plugins/bower_components/jquery.gritter/js/jquery.gritter.min.js"></script>
    <script src="../assets/global/plugins/bower_components/skycons-html5/skycons.js"></script>
    <!--/ END PAGE LEVEL PLUGINS -->

    <!-- DATEPICKER JS INICIO -->
    <script src="../assets/global/plugins/bower_components/moment/min/moment.min.js"></script>
    <script src="../assets/global/plugins/bower_components/bootstrap-daterangepicker/daterangepicker.js"></script>
    <script src="../limitless/assets/js/plugins/forms/validation/validate.min.js" type="text/javascript"></script>
    <!-- DATEPICKER JS FINAL -->

    <!-- START @PAGE LEVEL SCRIPTS -->
    <script src="../limitless/assets/js/plugins/forms/styling/uniform.min.js" type="text/javascript"></script>
    <script src="../limitless/assets/js/plugins/forms/selects/bootstrap_multiselect.js" type="text/javascript"></script>
    <script src="../assets/admin/js/apps.js"></script>
    <script src="../assets/admin/js/pages/blankon.dashboard.js"></script>
    <script src="../assets/plugin/datatables.min.js" type="text/javascript"></script>
    <script src="../assets/plugin/bootbox.min.js" type="text/javascript"></script>
    <script src="../assets/plugin/validateAlfi.js" type="text/javascript"></script>     
    <script src="../assets/plugin/select2.min.js" type="text/javascript"></script>
    <script src="../js/general.js" type="text/javascript"></script>
    <script type="text/javascript">
                 segundaCarga = () => {
                    initPickers.init()
                    initComponents.init()
                    DOMEvents.init()
                    initRequest.init()
                 }
                 const helpers = {
                    tblCharge() {
                       tableAsistencias.destroy()
                       initComponents.listarAsistencias()
                    },
                    tblRefresh() {
                       tableAsistencias.ajax.reload(null, false);
                    }
                 }

                 const httpRequest = {
                    listarCiclos(json) {
                       return new Promise((resolve, reject) => {
                          $.ajax({
                             type: 'POST',
                             url: "../ServletAsistencia?accion=listarCicloPorEstudiante",
                             dataType: "json",
                             data: {
                                json: JSON.stringify(json)
                             },
                             success: function (data, textStatus, jqXHR) {
                                resolve(data)
                             }, error: function (jqXHR, textStatus, errorThrown) {
                                reject('Error en la petición')
                             }
                          })
                       })
                    },
                    listarCiclosBusqueda(json) {
                       return new Promise((resolve, reject) => {
                          $.ajax({
                             type: 'POST',
                             url: "../ServletRecuperacion?accion=listarCiclos",
                             dataType: "json",
                             data: {
                                json: JSON.stringify(json)
                             },
                             success: function (data, textStatus, jqXHR) {
                                resolve(data)
                             }, error: function (jqXHR, textStatus, errorThrown) {
                                reject('Error en la petición')
                             }
                          })
                       })
                    },
                    registrarAsistencia(json) {
                       return new Promise((resolve, reject) => {
                          $.ajax({
                             type: 'POST',
                             url: "../ServletAsistencia?accion=registrarAsistencia",
                             dataType: "json",
                             data: {
                                json: JSON.stringify(json)
                             },
                             success: function (data, textStatus, jqXHR) {
                                resolve(data)
                             }, error: function (jqXHR, textStatus, errorThrown) {
                                reject('Error en la petición')
                             }
                          })
                       })
                    },
                    eliminarAsistencia(json) {
                       return new Promise((resolve, reject) => {
                          $.ajax({
                             type: 'POST',
                             url: "../ServletAsistencia?accion=eliminarAsistencia",
                             dataType: "json",
                             data: {
                                json: JSON.stringify(json)
                             },
                             success: function (data, textStatus, jqXHR) {
                                resolve(data)
                             }, error: function (jqXHR, textStatus, errorThrown) {
                                reject('Error en la petición')
                             }
                          })
                       })
                    },
                    editarAsistencia(json) {
                       return new Promise((resolve, reject) => {
                          $.ajax({
                             type: 'POST',
                             url: "../ServletAsistencia?accion=editarAsistencias",
                             dataType: "json",
                             data: {
                                json: JSON.stringify(json)
                             },
                             success: function (data, textStatus, jqXHR) {
                                resolve(data)
                             }, error: function (jqXHR, textStatus, errorThrown) {
                                reject('Error en la petición')
                             }
                          })
                       })
                    }
                 }

                 const DOMEvents = {
                    init() {
                       this.resetBusqueda()
                       this.abrirModalRegistro()
                       this.registrarAsistencia()
                       this.buscarAsistencias()
                       this.cancelarRegistro()
                       this.eliminarAsistencia()
                       this.abrirModalEdicion()
                       this.cancelarEdicion()
                       this.cargarCiclos()
                       this.checkSelects()
                       this.editarRecuperacion()
                       this.oneMinSelected()
                       this.generarExcel()
                    },
                    resetBusqueda() {
                       $('#btnLimpiar').click(() => {
                          $('#formBusqueda').trigger("reset");
                          $('#cboTipoBusqueda').change()
                          initPickers.rangePicker()
                          helpers.tblCharge()
                       })
                    },
                    generarExcel() {
                       $('#btnExcel').click(() => {
                          window.location = 'xlsAsistencia.jsp?filters=' + JSON.stringify(jsonBusqueda)
                       })
                    },
                    oneMinSelected() {
                       $(":checkbox:regex(value, ^div-busq)").change((e) => {
                          let target = e.currentTarget
                          let options = $('#cboTipoBusqueda').val()
                          let length = $('#cboTipoBusqueda option:selected').length
                          if (length >= 1) {
                             $('div:regex(id, ^div-busq)').addClass('hide')
                             for (let i in options) {
                                $('#' + options[i]).removeClass('hide')
                             }
                          } else {
                             $(target).parent().addClass('checked')
                             $("option[value='" + $(target).val() + "']").prop("selected", true)
                             $("#cboTipoBusqueda").multiselect("refresh");
                          }
                       })
                    },
                    cancelarRegistro() {
                       $('#btnCancelarRegistro').click(() => {
                          $('#registrarAsistencia').modal('hide')
                          $('#formNuevo').trigger("reset")
                       })
                    }
                    ,
                    cancelarEdicion() {
                       $('#btnCancelarEdicion').click(() => {
                          $('#editarAsistencia').modal('hide')
                          $('#formEditar').trigger("reset");
                       })
                    },
                    buscarAsistencias() {
                       $('#btnBuscar').click(() => {
                          var valBusqueda = $("#formBusqueda").validate({
                             rules: {
                                txtFechaBusqueda: {required: true},
                                cboCicloBusqueda: {required: true}
                             },
                             messages: {
                                txtFechaBusqueda: {required: "<b>&times;</b>&nbsp;Este campo es requerido"},
                                cboCicloBusqueda: {required: "<b>&times;</b>&nbsp;Este campo es requerido"}
                             }
                          });
                          if (valBusqueda.form()) {
                             helpers.tblCharge()
                          }
                       })
                    },
                    abrirModalRegistro() {
                       $('#btnNuevo').click(() => {
                          $('#registrarAsistencia').modal('show')
                       })
                    },
                    registrarAsistencia() {
                       $('#btnAgregarAsistencia').click(() => {
                          var valRegistroAsistencia = $("#formNuevo").validate({
                             rules: {
                                cboEstudianteRegistro: {required: true},
                                cboCicloRegistro: {required: true},
                                txtFechaRegistro: {required: true},
                                txtHoraRegistro: {required: true},
                                taObservacionRegistro: {required: true, spaceNotAllowed: true}
                             },
                             messages: {
                                cboEstudianteRegistro: {required: "<b>&times;</b>&nbsp;Este campo es requerido"},
                                cboCicloRegistro: {required: "<b>&times;</b>&nbsp;Este campo es requerido"},
                                txtFechaRegistro: {required: "<b>&times;</b>&nbsp;Este campo es requerido"},
                                txtHoraRegistro: {required: "<b>&times;</b>&nbsp;Este campo es requerido"},
                                taObservacionRegistro: {required: "<b>&times;</b>&nbsp;Este campo es requerido"}
                             },
                             errorPlacement:
                                     function (error, element) {
                                        if (element.attr("id") === "cboEstudianteRegistro") {
                                           error.insertAfter(".select2-container");
                                        } else {
                                           error.insertAfter(element);
                                        }
                                     }
                          });
                          if (valRegistroAsistencia.form()) {
                             httpRequest.registrarAsistencia(
                                     {
                                        codigoCiclo: $('#cboCicloRegistro').val(),
                                        codigoEstudiante: $('#cboEstudianteRegistro').val(),
                                        fechaAsistencia: $('#txtFechaRegistro').val(),
                                        horaIngreso: $('#txtHoraRegistro').val(),
                                        observacionAsistencia: $('#taObservacionRegistro').val()
                                     })
                                     .then((data) => {
                                        if (data.status) {
                                           $('#registrarAsistencia').modal('hide')
                                           msnSuccess("Asistencia agregada correctamente", () => {
                                              $('#formNuevo').trigger("reset")
                                              helpers.tblRefresh()
                                           })
                                        } else {
                                           msnError(data.message)
                                        }
                                     })
                          }
                       }
                       )
                    },
                    eliminarAsistencia() {
                       $('#tblAsistencias tbody').on('click', '.eliminar', (e) => {
                          let thisNode = e.currentTarget;
                          let data = tableAsistencias.row($(thisNode).parents('tr')).data();
                          msnConfirm(`<label>¿Seguro de eliminar esta Asistencia?</label>`, (option) => {
                             if (option) {
                                httpRequest.eliminarAsistencia(data)
                                        .then((data) => {
                                           if (data.status) {
                                              helpers.tblRefresh()
                                              msnSuccess("Asistencia correctamente eliminada")
                                           } else {
                                              if ((data.message).includes('--->')) {
                                                 msnError("Ha ocurrido un error")
                                              } else {
                                                 msnError(data.message)
                                              }
                                           }
                                        })
                                        .catch(err => console.log(err))
                             }
                          });
                       })
                    },
                    abrirModalEdicion() {
                       $('#tblAsistencias tbody').on('click', '.editar', (e) => {
                          let thisNode = e.currentTarget;
                          let data = tableAsistencias.row($(thisNode).parents('tr')).data();
                          $('#editarAsistencia').modal('show')
                          $('#txtEstudiante').text(" " + data.nombreEstudiante)
                          $('#txtAsistencia').text(" " + data.fechaAsistencia + " - " + data.horaAsistencia)
                          $('#cboEstadoAsistencia').val(data.estadoAsistencia)
                          $('#taObservacionesAsistencia').val(data.observacionAsistencia)
                          $('#codigoAsistencia').val(data.codigoAsistencia)
                       })
                    },
                    editarRecuperacion() {
                       $('#btnEditarAsistencia').click(() => {
                          var valRegistroRecuperacion = $("#formEditar").validate({
                             rules: {
                                cboEstadoAsistencia: {required: true},
                                taObservacionesAsistencia: {required: true, spaceNotAllowed: true}
                             },
                             messages: {
                                cboEstadoAsistencia: {required: "<b>&times;</b>&nbsp;Este campo es requerido"},
                                taObservacionesAsistencia: {required: "<b>&times;</b>&nbsp;Este campo es requerido"}
                             }
                          });
                          if (valRegistroRecuperacion.form()) {
                             httpRequest.editarAsistencia({
                                'estadoAsistencia': $('#cboEstadoAsistencia').val(),
                                'observacionAsistencia': $('#taObservacionesAsistencia').val(),
                                'codigoAsistencia': $('#codigoAsistencia').val()
                             })
                                     .then((data) => {
                                        if (data.status) {
                                           $('#editarAsistencia').modal('hide')
                                           helpers.tblRefresh()
                                           msnSuccess("Asistencia correctamente modificada", () => {
                                              $('#formEditar').trigger("reset");
                                           })
                                        } else {
                                           if ((data.message).includes('--->')) {
                                              msnError("Ha ocurrido un error")
                                           } else {
                                              msnError(data.message)
                                           }
                                        }
                                     })
                                     .catch(err => console.log(err))
                          }
                       })
                    },
                    checkSelects() {
                       $('#cboTipoFiltro').change((e) => {
                          _this = e.currentTarget
                          if (_this.value === '1') {
                             $('#colCiclo').removeClass('hide')
                             $('#colFecha').addClass('hide')
                          } else if (_this.value === '2') {
                             $('#colCiclo').addClass('hide')
                             $('#colFecha').removeClass('hide')
                          }
                       })
                    },
                    cargarCiclos() {
                       $('#cboEstudianteRegistro').change(() => {
                          initRequest.cargarCiclos()
                       })
                    }
                 }

                 const initRequest = {
                    init() {
                       this.cargarCIclosBusqueda()
                    },
                    cargarCiclos() {
                       httpRequest.listarCiclos({
                          codigoEstudiante: $('#cboEstudianteRegistro').val()
                       })
                               .then((data) => {
                                  if (data.status) {
                                     var lista = data.results;
                                     var print = " <option value=''>[SELECCIONE]</option> ";
                                     for (var i in lista) {
                                        print += " <option value ='" + lista[i].codigoCiclo + "'>" + capitalizeWords(lista[i].nombreCiclo) + "</option> ";
                                     }
                                     $(".cboCiclo").html(print);
                                  } else {
                                     var print = " <option value=''>No hay contenido</option> ";
                                     $(".cboCiclo").html(print);
                                  }
                               })
                               .catch(err => console.log(err))
                    },
                    cargarCIclosBusqueda() {
                       let json = {}
                       httpRequest.listarCiclosBusqueda(json)
                               .then((data) => {
                                  if (data.status) {
                                     var lista = data.results;
                                     var print = " <option value=''>[SELECCIONE]</option> ";
                                     for (var i in lista) {
                                        print += " <option value ='" + lista[i].codigoCiclo + "'>" + capitalizeWords(lista[i].nombreCiclo) + "</option> ";
                                     }
                                     $("#cboCicloBusqueda").html(print);
                                  } else {
                                     var print = " <option value=''>No hay contenido</option> ";
                                     $("#cboCicloBusqueda").html(print);
                                  }
                               })
                               .catch(err => console.log(err))
                    }
                 }
                 let jsonBusqueda = {}
                 const initComponents = {
                    init() {
                       this.multiselectBasic()
                       this.checkboxs()
                       this.listarAsistencias()
                       this.listarEstudiantes()
                    },
                    listarAsistencias() {
                       jsonBusqueda = {}
                       if ($('#cboEstadoBusqueda').val() !== "" && $('#cboTipoBusqueda').val().includes('div-busq-estado')) {
                          jsonBusqueda.estadoAsistencia = $('#cboEstadoBusqueda').val()
                       }
                       if ($('#cboTipoBusqueda').val().includes('div-busq-fecha')) {
                          let rangoFechas = $('#txtFechaBusqueda').val()
                          let fecha = rangoFechas.split(' - ')
                          jsonBusqueda.rangoInicioAsistencia = fecha[0]
                          jsonBusqueda.rangoFinAsistencia = fecha[1]
                       }
                       if ($('#cboEstudianteBusqueda').val() !== "" && $('#cboTipoBusqueda').val().includes('div-busq-estudiante')) {
                          jsonBusqueda.documentoEstudiante = $('#cboEstudianteBusqueda').val()
                       }
                       if ($('#cboCicloBusqueda').val() !== "" && $('#cboTipoBusqueda').val().includes('div-busq-ciclo')) {
                          jsonBusqueda.cicloEstudiante = $('#cboCicloBusqueda').val()
                       }
                       tableAsistencias = $("#tblAsistencias").DataTable({
                          "language": {
                             "lengthMenu": "Mostrar: _MENU_",
                             "zeroRecords": "&nbsp;&nbsp;&nbsp; No se encontraron resultados",
                             "info": "&nbsp;&nbsp;&nbsp; Mostrando del _START_ al _END_ de un total de _TOTAL_ registros",
                             "infoEmpty": "&nbsp;&nbsp;&nbsp; Mostrando 0 de 0 registros",
                             "search": "Filtrar:",
                             "loadingRecords": "Cargando...",
                             "processing": '<span style="width:100%;"><img src="../../img/ajax-loader-img.gif" alt=""/></span>',
                             "paginate": {
                                "first": "First",
                                "last": "Last",
                                "next": "Siguiente",
                                "previous": "Anterior"
                             }
                          },
                          dom: '<"datatable-scroll"t>r<"datatable-footers"ip>',
                          ajax: {
                             type: 'POST',
                             url: "../ServletAsistencia?accion=listarAsistencia",
                             data: {
                                json: JSON.stringify(jsonBusqueda)
                             }
                          },
                          "bSort": false,
                          "bFilter": false,
                          "serverSide": true,
                          "processing": true,
                          "aaSorting": [],
                          "ordering": false,
                          "bLengthChange": false,
                          "bInfo": true,
                          "paging": true,
                          "iDisplayLength": 15,
                          "columnDefs": [
                             {targets: 0, orderable: false, width: "5%", className: "text-center"},
                             {targets: 1, orderable: false, width: "15%"},
                             {targets: 2, orderable: false, width: "5%", className: "text-center"},
                             {targets: 3, orderable: false, width: "15%"},
                             {targets: 4, orderable: false, width: "5%", className: "text-center"},
                             {targets: 5, orderable: false, width: "5%", className: "text-center"},
                             {targets: 6, orderable: false, width: "5%", className: "text-center"},
                             {targets: 7, orderable: false, width: "25%"},
                             {targets: 8, orderable: false, width: "5%", className: "text-center"},
                             {targets: 9, orderable: false, width: "5%", className: "text-center"}
                          ],
                          "columns": [
                             {"data": "numeral"},
                             {"data": null, "render": (data, type, row) => {
                                   return capitalizeWords(row.nombreEstudiante);
                                }
                             },
                             {"data": "dniEstudiante"},
                             {"data": null, "render": (data, type, row) => {
                                   return capitalizeWords(row.nombreCiclo);
                                }
                             },
                             {"data": "fechaAsistencia"},
                             {"data": "horaAsistencia"},
                             {"data": null, "render": (data, type, row) => {
                                   return row.horaInicio + ' - ' + row.horaSalida
                                }
                             },
                             {"data": "observacionAsistencia", render: (data, type, row) => {
                                   if (data.length >= 1) {
                                      return data
                                   } else {
                                      return "Sin detalles"
                                   }
                                }
                             },
                             {"data": null, "render": (data, type, row) => {
                                   if (row.estadoAsistencia === 0) {
                                      return `<span class="label label-danger">FALTA</span>`
                                   } else if (row.estadoAsistencia === 1) {
                                      return `<span class="label label-success">ASISTENCIA</span>`
                                   } else if (row.estadoAsistencia === 2) {
                                      return `<span class="label label-warning">TARDANZA</span>`
                                   }
                                }
                             },
                             {"data": null, "render": (data, type, row) => {
                                   return `<span class='editar'><i class="fa fa-pencil bigger-140 blue"></i>&nbsp;&nbsp;</span>
                                                                     <span class='eliminar'><i class="fa fa-trash-o bigger-140 red"></i>&nbsp;&nbsp;</span>`
                                }
                             }

                          ]
                       });
                    },
                    listarEstudiantes() {
                       ajaxRemoteSelect2({
                          id: ".cboEstudiante",
                          url: '../ServletPermiso?accion=listarEstudiantes',
                          data: params => {
                             return {
                                search: params.term,
                                page: params.page || 1
                             };
                          }
                          ,
                          placeholder: 'Buscar por nombre o dni',
                          minimumInputLength: 1,
                          templateResult: repo => {
                             if (repo.loading) {
                                return repo.text;
                             }
                             var markup = '<option value="' + repo.id + '">' + repo.nombre + '</option>';
                             return markup;
                          },
                          templateSelection: repo => {
                             let text = 'Buscar por nombre o dni';
                             if (repo.id) {
                                text = repo.nombre;
                             }
                             return text;
                          }
                       });
                    },
                    multiselectBasic() {
                       $('#cboTipoBusqueda').multiselect({
                          numberDisplayed: 1
                       });
                    },
                    checkboxs() {
                       $(".styled, .multiselect-container input").uniform({radioClass: 'choice'})
                    }
                 }

                 var f = new Date();
                 var hoy = f.getDate() + "/" + (f.getMonth() + 1) + "/" + f.getFullYear()

                 const initPickers = {
                    init() {
                       this.rangePicker()
                       this.singlePicker()
                    },
                    rangePicker() {
                       $('.date-range-picker').daterangepicker({
                          "singleDatePicker": false,
                          "opens": "center",
                          "showDropdowns": false,
                          "autoApply": true,
                          "locale": {
                             "format": "DD/MM/YYYY",
                             "separator": " - ",
                             "customRangeLabel": "Personaliza",
                             "daysOfWeek": [
                                "Do",
                                "Lu",
                                "Ma",
                                "Mi",
                                "Ju",
                                "Vi",
                                "Sa"
                             ],
                             "monthNames": [
                                "Ene",
                                "Feb",
                                "Mar",
                                "Abr",
                                "May",
                                "Jun",
                                "Jul",
                                "Ago",
                                "Sep",
                                "Oct",
                                "Nov",
                                "Dic"
                             ],
                             "firstDay": 1
                          },
                          "drops": "down"
                       });
                    },
                    singlePicker() {
                       $('.date-single-picker').daterangepicker({
                          "singleDatePicker": true,
//                          "minDate": hoy.toString(),
                          "opens": "center",
                          "showDropdowns": false,
                          "autoApply": true,
                          "locale": {
                             "format": "DD/MM/YYYY",
                             "separator": " - ",
                             "customRangeLabel": "Personaliza",
                             "daysOfWeek": [
                                "Do",
                                "Lu",
                                "Ma",
                                "Mi",
                                "Ju",
                                "Vi",
                                "Sa"
                             ],
                             "monthNames": [
                                "Ene",
                                "Feb",
                                "Mar",
                                "Abr",
                                "May",
                                "Jun",
                                "Jul",
                                "Ago",
                                "Sep",
                                "Oct",
                                "Nov",
                                "Dic"
                             ],
                             "firstDay": 1
                          },
                          "drops": "down"
                       });
                    }
                 }
    </script>
  </body>
</html>
