<%-- 
    Document   : xlsAsistencia
    Created on : 05-sep-2018, 8:54:26
    Author     : Felipe Escala
--%>

<%@page import="pe.siso.academia.Beans.Usuario"%>
<%@page import="java.sql.Timestamp"%>
<%@page import="pe.siso.academia.Services.AsistenciaService"%>
<%@page import="org.json.JSONArray"%>
<%@page import="org.json.JSONObject"%>
<%@page contentType="text/html; charset=iso-8859-1" pageEncoding="UTF-8"%>

<!DOCTYPE html>
<html lang="en">
  <head>
    <%
      String json = request.getParameter("filters");
      JSONObject jobj = new JSONObject(json);
      jobj.put("draw", "1");
      jobj.put("start", "0");
      jobj.put("length", "-1");
      JSONObject jReturn = new JSONObject();
      JSONArray arrayReturn = new JSONArray();
      Timestamp timestamp = new Timestamp(System.currentTimeMillis());
      HttpSession session_actual = request.getSession(true);
      Usuario usuario = (Usuario) session_actual.getAttribute("usuario");
      jobj.put("codigoSede", usuario.getCodigoSede());
      response.setContentType("application/vnd.ms-excel");
      response.setHeader("Content-Disposition", "inline; filename=ReporteAsistencias" + timestamp.getTime() + ".xls");
      AsistenciaService service = new AsistenciaService();
      jReturn = service.listarAsistencia(jobj);
      arrayReturn = jReturn.getJSONArray("data");
    %>
    <!--    <style>
    
          label,h5,h2,td,.btn,li,option,select,p,b,input,span {
            font-family: 'Poppins', sans-serif;
            font-style: normal
          }
    
          th{
            font-weight: 100;
            font-family: 'Poppins', sans-serif;
          }
    
          td{
            margin : 0px;
            padding: 10px;
          }
        </style>-->

  </head>
  <body>
    <h3 align="center">REPORTE DE ASISTENCIAS</h3>

    <table border="1" align="center">
      <thead>
        <tr>
          <th style="text-align: center">N°</th>
          <th style="text-align: center">ESTUDIANTE</th>
          <th style="text-align: center">DNI</th>
          <th style="text-align: center">CICLO</th>
          <th style="text-align: center">FECHA</th>
          <th style="text-align: center">HORA ASISTENCIA</th>
          <th style="text-align: center">HORA CLASE</th>
          <th style="text-align: center">OBSERVACION</th>
          <th style="text-align: center">ESTADO</th>
        </tr>

      </thead>
      <tbody>
        <%
          int sizeArray = arrayReturn.length();
          for (int i = 0; i < sizeArray; i++) {
            JSONObject obj = arrayReturn.getJSONObject(i);
        %>
        <tr>
          <td align="center"><%=obj.getInt("numeral")%></td>
          <td align="left"><%=obj.getString("nombreEstudiante")%></td>
          <td align="center"><%=obj.getInt("dniEstudiante")%></td>
          <td align="left"><%=obj.getString("nombreCiclo")%></td>
          <td align="center"><%=obj.getString("fechaAsistencia")%></td>
          <td align="center"><%=obj.getString("horaAsistencia")%></td>
          <td align="center"><%=obj.getString("horaInicio") + " - " + obj.getString("horaSalida")%></td>
          <td align="left"><%=obj.getString("observacionAsistencia")%></td>
          <%
            switch (obj.getInt("estadoAsistencia")) {
              case 0:
          %>
          <td style="background-color: #BB091C; color: white" align="center"><%="FALTA"%></td>
          <%
              break;
            case 1:
          %>
          <td style="background-color: #8CC152; color: white" align="center"><%="ASITENCIA"%></td>
          <%
              break;
            case 2:
          %>
          <td style="background-color:#F5BB42; color: white" align="center"><%="TARDANZA"%></td>
          <%
                break;
              default:
            }
          %>
        </tr>
        <% }%>
      </tbody>
    </table>
    <br><br><br><br><br><br><br><br><br><br><br><br><br><br><br> 
    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;

  </body>
</html>
